package com.gx.obe.server.common.enumeration;

import com.gx.obe.server.common.utils.StringUtils;

/**
 * @Description: 
 * @author guoyr
 */
public class EngineerConstants {

	/**
	 * 工程项目类型(01：工程项目；02：单项工程；03：单位工程;04:分部分项；05：措施项目；06：其他项目)
	 */
	public static final String GCXM = "01";
	public static final String DXGC = "02";
	public static final String DWGC = "03";
	public static final String FBFX = "04";
	public static final String CSXM = "05";
	public static final String QTXM = "06";
	public static final String CSXM_DJ = "00";
	public static final String CSXM_ZJ = "01";
	
	/**
	 * 工程项目专业(01：建筑；02：装饰；03：安装；04：市政；05：园林)
	 */
	public static final String SPECIALTY_BUILD = "01";
	public static final String SPECIALTY_DECORATE = "02";
	public static final String SPECIALTY_INSTALL = "03";
	public static final String SPECIALTY_MUNICIPAL = "04";
	public static final String SPECIALTY_GARDEN = "05";
	
	/**
	 * 分部分项枚举(01：分部；02：清单；03：定额；04：费用)
	 */
	public static final String FBGC = "01";
	/**
	 * 分部分项枚举(01：措施；02：清单；03：定额；04：费用)
	 */
	public static final String CSGC = "01";
//	public static final String DJCS = "05";
//	public static final String ZJCS = "06";
	
	public static final String QD = "02";
	public static final String DE = "03";
	public static final String FY = "04";
	
	/**
	 * 暂估价(01：材料暂估价；02：专业工程暂估价；03：工程设备暂估单价)
	 */
	public static final String ZGJ_ROOT = "00";
	public static final String ZGJ_CL = "01";
	public static final String ZGJ_ZYGC = "02";
	public static final String ZGDJ_GCSB = "03";
	
	/**
	 * 计日工(01：人工费；02：材料费；03：机械费)
	 */
	public static final String JRG_ROOT = "00";
	public static final String JRG_RGFY = "01";
	public static final String JRG_CLFY = "02";
	public static final String JRG_JXFY = "03";
	public static String getDayWorksCn(String str){
		String jrgCN = "";
		if(StringUtils.isEmpty(str) || StringUtils.equals(JRG_ROOT, str)){
			jrgCN = "";
		}else if(StringUtils.equals(JRG_RGFY, str)){
			jrgCN = "人工";
		}else if(StringUtils.equals(JRG_CLFY, str)){
			jrgCN = "材料";
		}else if(StringUtils.equals(JRG_JXFY, str)){
			jrgCN = "机械";
		}
		return jrgCN;
	}
	
	/**
	 * 总承包服务费(01：发包人分包专业工程；02：发包人供应材料)
	 */
	public static final String FBR_ROOT = "00";
	public static final String FBR_FBZYGC = "01";
	public static final String FBR_GYCL = "02";
	
	/**
	 * 规费税金(01：规费；02：税金)
	 */
	public static final String GFXM = "01";
	public static final String SJXM = "02";
	
	/**
	 * 工料机汇总(00：其他；01：人工；02：材料；03：机械；04：主材；05：设备)
	 */
	public static final String RCJHZ_QT = "00";
	public static final String RCJHZ_RG = "01";
	public static final String RCJHZ_CL = "02";
	public static final String RCJHZ_JX = "03";
	public static final String RCJHZ_ZC = "04";
	public static final String RCJHZ_SB = "05";
	
	/**
	 * 00:规费;01安全文明施工费
	 */
	public static final String RATE_GF = "00";
	public static final String RATE_AQWMSGF = "01";
	
}
