package com.gx.obe.server.common.enumeration;

import com.gx.obe.server.common.utils.StringUtils;


public class EvaluationStepEnum {

	/**
	 * 评标步骤类型：01：签到；02：符合性评审；03：打分评审；04：价格评审；05：推荐
	 */
	public static final String SIGIN = "01";// 签到
	public static final String FEATURE_CHECK = "02";// 特征码检查
	public static final String CLEAN_TENDER = "03";// 清标
	public static final String COMPLIANCE = "04";// 符合性评审
	public static final String DETAIL = "05";// 打分评审
	public static final String PRICE = "06";// 价格评审
	public static final String RECOMMONED = "07";// 推荐中标候选人
	public static final String BID_PRICE_LIMIT = "08";// 投标限价
	public static final String RECOMMONED_RANK = "09";// 推荐排名
	public static final String VETO_BID = "10";// 否决中标评审
	public static final String BILL = "11";// 清单评审
	public static final String CREDIT = "12";// 综合信用评审
	public static final String MULTI_ROUNDS_PRICE = "13";// 多轮报价
	public static final String WASTE_BID = "14";// 废标
	public static final String TOTAL_PRICE = "15";// 合量评审
	public static final String PRE_EVALUATION = "16";// 预评审
	public static final String EDIT_PRICE = "17";// 价格评审
//	public static final String REBIDPRICE = "18";// 再次报价
	public static final String FIXED_FACTOR = "21";// 定档

	public static final String BILL_ZBT = "bill_zbt";
	public static final String BILL_YT = "bill_yt";
	public static final String BILL_BZ = "bill_bz";
	
	/**
	 * 是否对投标人进行筛选[00：不筛选；01：筛选]
	 */
	public static final String FILTER_YES = "01";
	public static final String FILTER_NO = "00";

	/**
	 * 汇总类型[00：全部;01：去除最高分和最低分;02:剔除超出预警范围的分值;03:按指标去掉最高最低;04:通过性得分;05:通过指标汇总]
	 */
	public static final String SUMMARY_ALL = "00";
	public static final String SUMMARY_REMOVE_MAX_MIN = "01";
	public static final String SUMMARY_IGNORE_OVER_WARNING_CORE = "02";
	public static final String SUMMARY_REMOVE_FACTOR_MAX_MIN = "03";
	public static final String SUMMARY_SCORE_BY_QUALIFIED = "04";
	public static final String SUMMARY_BY_FACTOR_SUM = "05";

	/**
	 * 投标人通过类型[00：一票否决；01：少数服从多数]
	 */
	public static final String PASS_ALL = "00";
	public static final String PASS_MORE = "01";
	
	/**
	 * 多轮报价来源
	 */
	public static final String LACOL = "00";
	public static final String REMOTE = "01";
	/**
	 * 多轮报价状态
	 */
	public static final String INCROSS = "00";
	public static final String COMPOLETE = "01";

	/**
	 * 投标人符合性评审评定结果（通过、不通过）[01：通过；02：不通过]
	 */
	public static final String QUALIFIED = "01";
	public static final String UNQUALIFIED = "02";

	public static final String getPreviewPassTypeCN(String str) {
		String type = "";
		if (StringUtils.isNotEmpty(str) && str.equals(PASS_MORE)) {
			type = "少数服从多数";
		} else {
			type = "一票否决";
		}
		return type;
	}

	/**
	 * 专家进行评审时是否按整体评审顺序进行评审[01：所有专家整体进度；02：个人自由进度;03:手动控制;04:个人不控制进度]
	 */
	public static final String ORDER_REVIEW_YES = "01";
	public static final String ORDER_REVIEW_NO = "02";
	public static final String ORDER_OPERATOR = "03";
	public static final String ORDER_SELF_FREE = "04";

	/**
	 * 角色[00：所有专家；01：专家组长：02：项目经理:03自定义专家04：按评标角色;05:按评审要素分组]
	 */
	public static final String EXPERT = "00";
	public static final String EXPERT_LEADER = "01";
	public static final String OPERATOR = "02";
	public static final String CUSTOM = "03";
	public static final String EVAL_BID_TYPE = "04";
	public static final String EVAL_GROUP = "05";

	public static final String SIGN_DEFAULT_IMAGE = "icons/sign.png";
	public static final String COMPLIANCE_DEFAULT_IMAGE = "icons/compliance.png";
	public static final String FEATURE_DEFAULT_IMAGE = "icons/feature_check.png";
	public static final String CLEAN_TENDER_DEFAULT_IMAGE = "icons/clean_tender.png";
	public static final String SCORE_DEFAULT_IMAGE = "icons/detail.png";
	public static final String PRICE_DEFAULT_IMAGE = "icons/price.png";
	public static final String OPINION_INPUT_DEFAULT_IMAGE = "icons/opinion.png";
	public static final String NEGOTIATION_INPUT_DEFAULT_IMAGE = "icons/negotiation.png";
	public static final String PRICE_INPUT_DEFAULT_IMAGE = "icons/price_input.png";
	public static final String RECOMMONED_DEFAULT_IMAGE = "icons/recommoned.png";

	/**
	 * 视图类型[EVALUATION_TYPE_AI：智能评审；EVALUATION_TYPE_SINGLE：单项评审；EVALUATION_TYPE_COLLECT：集中评审]
	 */
	public static final String EVALUATION_TYPE_AI = "EVALUATION_TYPE_AI";
	public static final String EVALUATION_TYPE_SINGLE = "EVALUATION_TYPE_SINGLE";
	public static final String EVALUATION_TYPE_COLLECT = "EVALUATION_TYPE_COLLECT";
	
	public static String getEvaluationStepIco(String stepType) {
		if (stepType.equals(EvaluationStepEnum.SIGIN)) {
			return "icons/evaluaton_step/sign.png";
		}
		if (stepType.equals(EvaluationStepEnum.FEATURE_CHECK)) {
			return "icons/evaluaton_step/feature_check.png";
		}
		if (stepType.equals(EvaluationStepEnum.CLEAN_TENDER) || stepType.equals(EvaluationStepEnum.PRE_EVALUATION)) {
			return "icons/evaluaton_step/clear.png";
		}
		if (stepType.equals(EvaluationStepEnum.COMPLIANCE)) {
			return "icons/evaluaton_step/compliance.png";
		}
		if (stepType.equals(EvaluationStepEnum.DETAIL)) {
			return "icons/evaluaton_step/score.png";
		}
		if (stepType.equals(EvaluationStepEnum.PRICE) || stepType.equals(EvaluationStepEnum.TOTAL_PRICE) || stepType.equals(EvaluationStepEnum.BID_PRICE_LIMIT) || stepType.equals(EvaluationStepEnum.MULTI_ROUNDS_PRICE)) {
			return "icons/evaluaton_step/price.png";
		}
		if (stepType.equals(EvaluationStepEnum.RECOMMONED)) {
			return "icons/evaluaton_step/recommoned.png";
		}
		if (stepType.equals(EvaluationStepEnum.BID_PRICE_LIMIT)) {
			return "icons/evaluaton_step/price.png";
		}
		if (stepType.equals(EvaluationStepEnum.RECOMMONED_RANK)) {
			return "icons/evaluaton_step/recommoned.png";
		}
		if (stepType.equals(EvaluationStepEnum.VETO_BID)) {
			return "icons/evaluaton_step/compliance.png";
		}
		if (stepType.equals(EvaluationStepEnum.BILL)) {
			return "icons/evaluaton_step/engineering.png";
		}
		if (stepType.equals(EvaluationStepEnum.CREDIT)) {
			return "icons/evaluaton_step/score.png";
		}
		return "icons/evaluaton_step/default.png";
	}

	
	public static final String STEP_TEMPLATE = "stepTemplate";
	public static final String STEP_TEMPLATE_NAME = "stepTemplateName";
	public static final String STEP_TEMPLATE_MEMO = "stepTemplateMemo";
	public static final String STEP_TEMPLATE_FILE_NAME = "stepTemplateFileName";
	public static final String IS_DEFAULT_TEMPLATE = "isDefaultTemplate";
	
	/**
	 * 参数：专家打分保留小数位数
	 */
	public static final String EXPERT_SCORE_ROUND = "EXPERT_SCORE_ROUND";
	/**
	 * 参数：通过评审要素单元分组评审
	 */
	public static final String PARAM_EVAL_BY_GROUP = "PARAM_EVAL_BY_GROUP";

	/**
	 * 参数：允许导入其他专家的结果
	 */
	public static final String PARAM_IMPORT_OTHERE_EXPERT_RESULT = "PARAM_IMPORT_OTHERE_EXPERT_RESULT";

	/**
	 * 参数：允许导入历史结果
	 */
	public static final String PARAM_IMPORT_HISTORY_RESULT = "PARAM_IMPORT_HISTORY_RESULT";

	/**
	 * 参数：自动导入历史打分
	 */
	public static final String PARAM_AUTO_IMPORT_HISTORY = "PARAM_AUTO_IMPORT_HISTORY";

	/**
	 * 参数：按供应商打分
	 */
	public static final String PARAM_EVALUATION_BY_SUPPLIER = "PARAM_EVALUATION_BY_SUPPLIER";

	/**
	 * 参数：评审得分方式为通过性得分
	 */
	public static final String PARAM_EVALUATION_SCORE_BY_PASS = "PARAM_EVALUATION_SCORE_BY_PASS";
	
	/**
	 * 参数：符合性评审中允午修改结果
	 */
	public static final String PARAM_ALLOW_EDIT_CONCLUSION = "PARAM_ALLOW_EDIT_CONCLUSION";
	
	/**
	 * 参数：允许不打分
	 */
	public static final String PARAM_EVALUATION_EMPTY = "PARAM_EVALUATION_EMPTY";
	
	/**
	 * 参数：显示汇总结果
	 */
	public static final String SHOW_SUMMARY_RESULT = "SHOW_SUMMARY_RESULT";
	
	/**
	 * 参数：完成评审时进行电子签章
	 */
	public static final String PARAM_EXPER_SIGNATURE = "PARAM_EXPER_SIGNATURE";

	/**
	 * 参数：剔除超出预警范围的分值后如果没有效得分，则取最低值
	 */
	public static final String PARAM_IGNORE_OVER_WARNING_USE_MIN = "PARAM_IGNORE_OVER_WARNING_USE_MIN";
	
	/**
	 * 参数：定档
	 */
	public static final String PARAM_FIXED_FACTOR = "PARAM_FIXED_FACTOR";
	public static final String PARAM_FIXED_FACTOR_VALUE = "PARAM_FIXED_FACTOR_VALUE";
	/**
	 * 参数：定档指标ID
	 */
	public static final String PARAM_FIXED_FACTOR_ID = "PARAM_FIXED_FACTOR_ID";
	/**
	 * 参数：定档指标CODE
	 */
	public static final String PARAM_FIXED_FACTOR_CODE = "PARAM_FIXED_FACTOR_CODE";
	/**
	 * 参数：定档指标列表JSON
	 */
	public static final String PARAM_FIXED_FACTOR_LIST = "PARAM_FIXED_FACTOR_LIST";
	/**
	 * 参数：定档供应商得分JSON
	 */
	public static final String PARAM_FIXED_FACTOR_SUPPLIER_LIST = "PARAM_FIXED_FACTOR_SUPPLIER_LIST";
	
	/**
	 * 参数：暗标评审
	 */
	public static final String PARAM_SEALED_BID = "PARAM_SEALED_BID";
	/**
	 * 参数：暗标评审标书权限（即指定哪类标书为暗标）
	 */
//	public static final String PARAM_SEALED_BID_FILE_ROLE = "PARAM_SEALED_BID_FILE_ROLE";

	/**
	 * 参数：按暗标编码排序
	 */
	public static final String PARAM_ORDERBY_SEALED_BID_CODE = "PARAM_ORDERBY_SEALED_BID_CODE";

	/**
	 * 参数：序号显示投标编号
	 */
	public static final String PARAM_INDEX_IS_BIDNUMBER = "PARAM_INDEX_IS_BIDNUMBER";

	/**
	 * 参数：打分步骤入围得分
	 */
	public static final String PARAM_FILTER_SCORE = "PARAM_FILTER_SCORE";
	/**
	 * 参数：预警范围
	 */
	public static final String PARAM_WARNING_RANGE = "PARAM_WARNING_RANGE";

	/**
	 * 参数：忽略超出预警范围的分值
	 */
	public static final String PARAM_IGNORE_OVER_WARNING_RANGE = "PARAM_IGNORE_OVER_WARNING_RANGE";
	
	/**
	 * 参数：是否显示限价
	 */
	public static final String IS_SHOW_LIMIT_PRICE = "IS_SHOW_LIMIT_PRICE";
	
	/**
	 * 参数：是否显示投标报价
	 */
	public static final String IS_SHOW_BID_PRICE = "IS_SHOW_BID_PRICE";
	
	/**
	 * 参数：默认推荐排名数量
	 */
	public static final String RECOMMEND_COUNT = "RECOMMEND_COUNT";
	
	/**
	 * 参数：信用得分信息网名称
	 */
	public static final String PARAM_CREDIT_SOURCE_NAME = "PARAM_CREDIT_SOURCE_NAME";
	
	/**
	 * 参数：信用得分转换率 投标截止当日从河北建设工程信息网中查询的得分/120*100
	 */
	public static final String PARAM_CREDIT_RATE = "PARAM_CREDIT_RATE";
	
	/**
	 * 参数：是否匿名表决废标
	 */
	public static final String PARAM_IS_ANONYMOUS = "PARAM_IS_ANONYMOUS";
	
	/**
	 * 参数：是否需要表决废标
	 */
	public static final String PARAM_WASTE_NEED_VOTE = "PARAM_WASTE_NEED_VOTE";
	/**
	 * 参数：是否允许修改基准价
	 */
	public static final String PARAM_CHANGEBASEPRICE = "PARAM_CHANGMARKPRICE";
	/**
	 * 参数：是否允许修改报价得分
	 */
	public static final String PARAM_CHANGEPRICESCORE = "PARAM_CHANGEPRICESCORE";
	/**
	 * 参数：是否允许修正报价
	 */
	public static final String ALLOW_EDIT_PRICE = "ALLOW_EDIT_PRICE";
	/**
	 * 参数：设置偏离性条款否决投标的条数
	 */
	public static final String  UNQUALIFIED_DEVIATE_CLAUSE_COUNT = "UNQUALIFIED_DEVIATE_CLAUSE_COUNT";
	/**
	 * 参数：对于一致性检查指标必须检查是否评审一致，否则不允许提交
	 */
	public static final String CHECK_SAME_EVALUATION = "CHECK_SAME_EVALUATION";
	/**
	 * 参数：偏离性指标上浮百分比
	 */
	public static final String FLOATING_EVALUATION_PRICE_PERCENT = "FLOATING_EVALUATION_PRICE_PERCENT";
	
	/**
	 * 参数：指标类型
	 */
	public static final String FACTOR_TYPE = "FACTOR_TYPE";
	
	/**
	 * 是否包含符合性指标
	 */
	public static final int FACTOR_COMPLIANCE = 1 << 1;
	/**
	 * 是否包含打分指标
	 */
	public static final int FACTOR_SCORE = 1 << 2;
	
	/**
	 * 参数：评审类型
	 */
	public static final String EVALUATION_TYPE = "EVALUATION_TYPE";
	
	public static final String EVALUATION_MIN_SCORE = "EVALUATION_MIN_SCORE";
	public static final String BIDPRICE_SOURCE = "BidPriceSource";
	public static final String MAX_ROUND = "MaxRound";
	
}
