package com.gx.obe.server.config;

 import com.gx.obe.server.config.token.TokenInterceptor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import java.util.ArrayList;
import java.util.List;

/** 
 * @Description: web拦截器配置类
 * @author mazc 
 */
@Configuration
public class WebConfiguration implements WebMvcConfigurer {

    @Autowired
    private TokenInterceptor tokenInterceptor;

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        List<String> excludePath = new ArrayList<>();
        excludePath.add("/error");
        excludePath.add("/connection/");
        excludePath.add("/authUser/login");
        excludePath.add("/authUser/insert");
        excludePath.add("/authUser/login/login");
        excludePath.add("/authUser/loginRemote");
        excludePath.add("/connection/getTime");
        excludePath.add("/sysConfig/**");
        excludePath.add("/sysConfigValue/**");
        excludePath.add("/bidFileUploader/**");
        excludePath.add("/download/**");
        excludePath.add("/uploader/**");
        excludePath.add("/videoUploader/**");
        excludePath.add("/machine/isExist");
        excludePath.add("/machine/applyMachine");
        excludePath.add("/machine/getEvalRoomIdByMachineMacAndUseStatus");
        excludePath.add("/sysLog/addOperationLog");
        excludePath.add("/sysLog/getSysLogInfo");
        excludePath.add("/baseDictionaryValue/getDictValueListByDicCode");
        excludePath.add("/projectTemplate/getAllList");
        excludePath.add("/projectTemplate/getLatestModifyTime");
        excludePath.add("/scancode/receiveAppScanData");
        excludePath.add("/softwareUpload/checkFileMD5");
        excludePath.add("/software/getSoftwareList");
        excludePath.add("/software/getSoftwareByCode");
        excludePath.add("/tripartiteFunction/bidata/**");
        excludePath.add("/tenderProject/copyTenderProject");
        excludePath.add("/authUser/updatePhone");
        excludePath.add("/authUser/updatePassword");
        registry.addInterceptor(tokenInterceptor)
                .addPathPatterns("/**")
                .excludePathPatterns(excludePath);
        WebMvcConfigurer.super.addInterceptors(registry);

    }
}
