package com.gx.obe.server.config.token.util;

 

import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import com.auth0.jwt.JWT;
import com.auth0.jwt.algorithms.Algorithm;
import com.auth0.jwt.exceptions.JWTCreationException;
import com.auth0.jwt.interfaces.DecodedJWT;
import com.gx.obe.server.common.utils.AESUtil;
import com.gx.obe.server.common.utils.IpUtil;
import com.gx.obe.server.management.user.entity.AuthUserEntity;

/** 
 * @Description: 工具类（生成）
 * @author mazc 
 */
public class TokenUtil {
	
    private static final long EXPIRE_TIME = 1 * 60 * 60*1000; //token到期时间2小时
    private static final long ADVANCE_EXPIRE_TIME = 15*60*1000; //  小于15分钟生成新token
    public static final String TOKEN_SECRET = "ljdyaishijin**3nkjnj??";  //密钥盐
    public static final String IP = "01";
    public static final String USERID = "02";
    public static final String USERIDACCOUNT = "03";
    public static final String AUTH = AESUtil.encrypt("gxKpbgj");//发行人
    
    public static String sign(AuthUserEntity user,HttpServletRequest request){
    	String token=null;
    	try {
            Date expireAt=new Date(System.currentTimeMillis()+EXPIRE_TIME);
            token = JWT.create()
            		.withIssuer(AUTH)
                    .withClaim(USERID,AESUtil.encrypt(user.getId()))
                    .withClaim(USERIDACCOUNT, AESUtil.encrypt(user.getUserAccount()))
                    .withClaim(IP, AESUtil.encrypt(IpUtil.getIpAddr(request)))//ip
                    .withExpiresAt(expireAt)//过期时间
                    .sign(Algorithm.HMAC256(TOKEN_SECRET));
        } catch (IllegalArgumentException| JWTCreationException je) {

        }
        return token;
    }
    
    public boolean checkToken(String token){
    	try {
    		DecodedJWT decodedJWT = JWT.decode(token); 
    		long date = decodedJWT.getExpiresAt().getTime();
    		long diff = date - System.currentTimeMillis();
    		 if (diff < ADVANCE_EXPIRE_TIME) {
                 return true;
             }
    		 return false;
    	} catch (Exception e) {
    		 return false;
    	}
     }
    
}
