package com.gx.obe.server.im.serverthread;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.UnsupportedEncodingException;
import java.net.InetAddress;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;

import com.gx.obe.server.im.ChatConstants;
import com.gx.obe.server.im.IMConstants;
import com.gx.obe.server.im.SendFileParam;
import com.gx.obe.server.im.serverthread.SendFileThread.ServerSendFileListener;

/**<pre>
 * @Description: 监听并处理连接到服务器上的客户端进行的任何事件
 * @Description:
 * @author guoyr
 * </pre>
 */
public class ClientBean implements Runnable {
		private Socket socket; 
        private BufferedInputStream bis;
        private BufferedOutputStream bos;
        private boolean cont = false; 
        private List<byte[]> bytesList;
        private Logger LOG = org.slf4j.LoggerFactory.getLogger(ClientBean.class);
        private InetAddress myIpAddress;
        private String myId = "";
//        private Vector<ClientBean> clientList;
	    private List<ServerFileThread> sendFileThreadList; 
        
        private String serverIp;
        private Thread thread;
        private int threadId = 0;
	    private ServerListener clientListener;
	    private ServerSendFileListener serverSendFileListener;
        public InetAddress getIpAddress(){
            return myIpAddress;
        }
        public String getMyid(){
            return myId;
        }
//        public ClientBean(InetAddress ip, String clientId){
//            this.myIpAddress = ip;
//            this.myId = clientId;
//        }
        
        public boolean isFindUid(String clientId){
            if ( myId == null && clientId != null ) return false;
            return this.myId.equals(clientId);
        }
        
        public boolean isFindIp(InetAddress ip){
            return (null != myIpAddress && this.myIpAddress.getHostAddress().equalsIgnoreCase(ip.getHostAddress()))?true:false;
        }
        
        @Override
        public int hashCode() {
            final int prime = 31;
            int result = 1;
            result = prime * result + (int)thread.getId();// this.myId;;
            return result;
        }
        @Override
        public boolean equals(Object obj) { 
            if (obj == null || getClass() != obj.getClass() )
              return false;
            if (this == obj)
              return true;
            if (myId.equals(((ClientBean) obj).getMyid())/* null != myIpAddress &&  
                    && myIpAddress.getHostAddress().equalsIgnoreCase( ((ClientBean) obj).getIpAddress().getHostAddress() ) */&& this.getThreadId() == ((ClientBean) obj).getThreadId())
                return true;
            else
                return false;
        }
        
	    public ClientBean(String serverIp, Socket socket, ServerListener clientListener){
	    	this.clientListener = clientListener;
	    	this.serverIp = serverIp;
            this.socket = socket;
           
        }
		
	    public void start(){
	    	thread = new Thread(this);
	    	threadId = (int)thread.getId();
	    	thread.setName("终端线程");
	    	thread.start();
	    }
	   
        public void run() { 
        	bytesList = new ArrayList<byte[]>();
            sendFileThreadList = new ArrayList<ServerFileThread>();
            createServerSendFileListener();
            
        	 try { 
                 bis = new BufferedInputStream(socket.getInputStream());
                 bos = new BufferedOutputStream(socket.getOutputStream());
                 myIpAddress = socket.getInetAddress();
                 cont = true;
             } catch (Exception e) {
             	LOG.error(e.getMessage());
             } 
            try {
                int endFlagIndex = -1;
                
                while (cont) {
                    byte[] bs = new byte[ChatConstants.MAX_LENGTH];
                    int len = bis.read(bs);
                    if ( len == -1 ) break;
                    byte[] tb = new byte[len];
                    for ( int i = 0; i < len; i ++ ){
                        tb[i] = bs[i];
                    }
                    //保存本次接收的字节内容到集合
                    bytesList.add(tb);
                    
                    int totalPackLength = getTotalPackLength();
                    if ( endFlagIndex == -1 ){
                    	// 获得消息结束标记
                    	endFlagIndex = getEndFlagIndex(totalPackLength);
                    }
                    // 如果没有找到消息结束标记,则认为没有获得一条完整的消息,就继续收数据，直到找到 ChatMain.END_TAG为止
                    if ( endFlagIndex == - 1 ){ 
                        continue;
                    }
                    
                    String readStr = getPackStr(totalPackLength);//0,284de942c8fb4d80ae71c67f5e36bdca,1.7-]
//                    area.append("刚收到=" + readStr + "\n");
                    endFlagIndex = -1;
                    bytesList.clear();
                    
                    // 如果没有找到结束标记,则说明在转换为消息字符串时出错
                    if(readStr.indexOf(ChatConstants.END_TAG) == -1){
                    	continue;
                    }
                    
                    readStr = readStr.substring(0, readStr.indexOf(ChatConstants.END_TAG) );
                    
                    // 获得第一个标记位为命令
                    String commond = readStr.substring(0,1);
                    
                    // 如果是登录
                    if (commond.equals(IMConstants.LOGIN_IN)){
                        if (readStr.lastIndexOf(ChatConstants.FENGEFU) == 1 ){
                            readStr = "" + IMConstants.LOW_VERSION;
                        }else{
                        	////0,284de942c8fb4d80ae71c67f5e36bdca,1.7-]
//                            String version = readStr.substring(readStr.lastIndexOf(FENGEFU) + FENGEFU.length());
                            readStr = readStr.substring(0, readStr.lastIndexOf(ChatConstants.FENGEFU));
                            this.myId = readStr.substring(2); 
//                            QueryWrapper queryWrapper = new QueryWrapper(Employee.class);
//                            queryWrapper.setWhereParam("objId", uid);
//                            queryWrapper.setParm("lineStatus", EmployeeEnum.ON_LINE);
//                            employeeService.update(queryWrapper);
                        }
                        readStr = IMConstants.LOGIN_IN + ChatConstants.FENGEFU + this.myId;
                        
                        // 告诉服务器该终端登录成功
                        clientListener.connectionSuccess(this);
                        
                        // 检查该终端是否已经登录
                        clientListener.checkLogin(myId, threadId);
                        
                    }else if (commond.equals(IMConstants.SEND_FILE_REQUEST)){ // 发送文件请求
                    	// 接收到服务器发送的文件发送请求，即服务器通知有需要接收的文件
                    	SendFileParam params = SendFileParam.getFileParams(readStr);
//                    	params.setSendIp(myIpAddress.getHostAddress());// 发送方作为服务器
                    	params.setSendIp(serverIp);// 采用服务器进行中转
                        clientListener.sendFileRequest(params.getReceiveId(), params.getOrderStr());
                    	continue;
                    }else if (commond.equals(IMConstants.SEND_FILE_BY_SERVER_REQUEST)){ // 通过服务器转发文件请求
                    	//a/284de942c8fb4d80ae71c67f5e36bdca/2c95650a13e5450c9ee1b7669ce713c7/b298fd27943b4b278f23c750edd3c76f/CrossExcelTest.java/10259//0/38/0-]
                    	SendFileParam params = SendFileParam.getFileParams(readStr);
                    	// 由服务器进行转发，则设置发送ip为服务器ip
                    	params.setSendIp(this.serverIp);
                    	
                    	// 启动转发文件的线程
                    	ServerFileThread serverFileThread = clientListener.sendFileByServerRequest(params, serverSendFileListener);
                    	sendFileThreadList.add(serverFileThread);
                    	LOG.debug("启动一个通过服务器转发文件的线程" + serverFileThread.getThreadId() +"总"+ sendFileThreadList.size()+"个服务器线程");
                    	continue;
                    }else if (commond.equals(IMConstants.SEND_OFFLINE_FILE)){ 
                    	SendFileParam params = SendFileParam.getFileParams(readStr);
                    	params.setOrder(IMConstants.CANCEL_SEND_FILE);
                    	stopServerFileThread(params.getThreadId());
                    	// 先取消正在发送的文件
                        clientListener.cancelSendFile(params.getReceiveId(), params.getOrderStr());
//                        cancelSendFile(str);
//                        readStr += FG + serverIp;
                        // 然后开始发送离线文件，并传入服务器的ip
                        params.setOrder(IMConstants.SEND_OFFLINE_FILE);
                        params.setSendIp(serverIp);
                        
                        ServerFileThread serverFileThread = clientListener.sendOfflineFile(myIpAddress, params.getOrderStr(), serverSendFileListener);
                        sendFileThreadList.add(serverFileThread);
                        LOG.debug("启动一个发送离线文件的线程" + serverFileThread.getThreadId() +"总"+ sendFileThreadList.size()+"个服务器线程");
                    	continue;
                    }else if (commond.equals(IMConstants.QUIT_OUT)){
                    	// 当监听到该终端退出登录
                    	readStr = IMConstants.QUIT_OUT + ChatConstants.FENGEFU + this.myId;
                    	quitOutAction();
                    }else if (commond.equals(IMConstants.CANCEL_SEND_FILE) || commond.equals(IMConstants.CANCEL_ALL_SEND_FILE)){  //取消在线文件发送
                    	SendFileParam params = SendFileParam.getFileParams(readStr);
                    	clientListener.cancelSendFile(params.getReceiveId(), readStr);
                    	stopServerFileThread(params.getThreadId());
                    	continue;
                    }else if (commond.equals(IMConstants.CHANGE_SEND_OFFLINE_FILE)){ 
                    	
                    	sendOfflineFileFromServerToClientThread(readStr);
                    	continue;
                    }else if(commond.equals(IMConstants.VIDEO_REQUEST)){// 发送视频请求
                    	String[] param = readStr.split(ChatConstants.FG);
                    	final String sendId = param[1];
                    	final String receiveId = param[2];
//                    	final String videoPort = param[3];
//                    	final String auditPort = param[4];
                    	final String str = param[0] + ChatConstants.FG + sendId + ChatConstants.FG + receiveId + ChatConstants.FG + myIpAddress.getHostAddress();// + FG + videoPort + FG + auditPort;
//                    	sendVideoRequest(receiveId, str);
                    	clientListener.sendVideoRequest(receiveId, str);
                    	continue;
                    	
                    }else if(commond.equals(IMConstants.ACCEPT_VIDEO)){// 接收视频请求
                    	String[] param = readStr.split(ChatConstants.FG);
                    	final String sendId = param[1];
                    	final String receiveId = param[2];
                    	final String videoPort = param[3];
                    	final String auditPort = param[4];
                    	final String str = param[0] + ChatConstants.FG + sendId + ChatConstants.FG + receiveId + ChatConstants.FG + myIpAddress.getHostAddress() + ChatConstants.FG + videoPort + ChatConstants.FG + auditPort;
                    	clientListener.receiveVideo(receiveId, str);
//                    	showVideo(receiveId, str);
                    	continue;
                    	
                    }else if (commond.equals(IMConstants.CLOSE_VIDEO)){  // 取消视频
                    	String receiveId = readStr.split(ChatConstants.FG)[2];
                    	clientListener.cancelVideo(receiveId, readStr);
//                    	cancelVideo(readStr); //关闭视频
                    	continue;
                    }else if (commond.equals(IMConstants.QUIT_OUT_AND_CLEAR)){ //客户端退了，让服务器清理线程(在服务器端启动的文件转发线程)
                    	String[] param = readStr.split(ChatConstants.FG);
                        for ( int k = 1; k < param.length; k ++ ){
                            long tid = Long.parseLong(param[k]);
                            stopServerFileThread(tid);
                        }
                    	continue;
                    }else if (commond.equals(IMConstants.QUIT_OUT_AND_DELETE_FILE)){ //客户端退了，让服务器清理线程，同时删除未收的文件
                    	String[] param = readStr.split(ChatConstants.FG);
                        for ( int k = 1; k < param.length; k ++ ){
                            long tid = Long.parseLong(param[k]);
                            stopServerFileThread(tid);
                        }
                    	continue;
                    }else if ( commond.equals(IMConstants.SHANPING)){ //发送一个闪屏
                    	String[] param = readStr.split(ChatConstants.FG); 
                    	final String receiveId = param[2];
                        final String str = readStr;
                        clientListener.sendShanPing(receiveId, str);
//                        sendShanPingFlag(tuid, str);
                        continue;
                    }
                    else if (commond.equals(IMConstants.RE_LOGIN_IN)){ //让客户端断线并重新登录
                    	sendToClient(IMConstants.RE_LOGIN_IN);//让客户端断线重新登录
                    	for ( int i = 0; i < sendFileThreadList.size(); i++ ){
                			ServerFileThread t = sendFileThreadList.get(i);
                			t.stop();
                			sendFileThreadList.remove(t);
                			i--;
                    	}
                        clientListener.reLogin(this.myId);
                        continue;
                    }
                    else if (commond.equals(IMConstants.NOTICE)){
                    	readStr = readStr.substring(2); 
                    	int receiveIdStartIndex = readStr.indexOf(ChatConstants.FENGEFU);
                    	String receiveId = readStr.substring(0, receiveIdStartIndex);
        				readStr = readStr.substring(receiveIdStartIndex + ChatConstants.FENGEFU.length()); 
        				int noticeIdStartIndex = readStr.indexOf(ChatConstants.FENGEFU);
        				String noticeId = readStr.substring(0, noticeIdStartIndex);
        				readStr = readStr.substring(noticeIdStartIndex + ChatConstants.FENGEFU.length()); 
        				String systemNotice = IMConstants.NOTICE.concat(ChatConstants.FENGEFU).concat(null != noticeId ? noticeId : "").concat(ChatConstants.FENGEFU).concat(readStr).concat(ChatConstants.END_TAG);
        				clientListener.sendNotice(receiveId, systemNotice);
                        continue;
                    }
                    //开始向在线客户端（除自己外）发送更新消息标志
                    if (readStr.equals(IMConstants.LOW_VERSION)){
                        sendToClient(readStr);
                    }else{
                    	clientListener.sendCommondToAllClient(readStr);
                    }
                }
            } catch (Exception ex){
            	LOG.error(ex.getMessage());
            } finally {
            	stop();
            }
        }
        public void stop(){
	    	cont = false;
	    	clientListener.quitOut(this);
        	if ( bis != null ){
        		try {
        			bis.close();
        		} catch (Exception e) {
        		}
        	}
        	if ( bos != null ){
        		try {
        			bos.close();
        		} catch (Exception e) {
        		}
        	}
        	if (socket != null) {
        		try {
        			socket.close();
        		} catch (Exception e) {
        		}
        		socket = null; 
        	}
        	bytesList.clear();
        	for(int i = 0; i < sendFileThreadList.size(); i++){
        		ServerFileThread sendFileThread =  sendFileThreadList.get(i);
        		sendFileThread.stop();
        		i--;
        	}
        	sendFileThreadList.clear();
	    }
        
        /**
         * @Description:  获得消息结束标记
         * @author guoyr
         * @return
         */
        private int getEndFlagIndex(int totalPackLength){ 
//            byte[] xb = new byte[getTotalPackLength()];
            byte[] xb = new byte[totalPackLength];
            int xi = 0;
            for ( int i = 0; i < bytesList.size(); i ++ ){
                byte[] b = (byte[]) bytesList.get(i);
                for ( int j = 0; j < b.length; j ++ ){
                    xb[xi++] = b[j];
                }
            }
            String str = new String(xb);
            int n = str.indexOf(ChatConstants.END_TAG);
            if ( n != -1 ){
            	return str.substring(0,n+ChatConstants.END_TAG.length()).getBytes().length;
            }
            return n;
        }
        
        /**
         * @Description:  获得接收到包的字符串
         * @author guoyr
         * @param totalPackLength
         * @return
         */
        private String getPackStr(int totalPackLength){ 
//            byte[] xb = new byte[getTotalPackLength()];
            byte[] xb = new byte[totalPackLength];
            int xi = 0;
            for ( int i = 0; i < bytesList.size(); i ++ ){
                byte[] b = (byte[]) bytesList.get(i);
                for ( int j = 0; j < b.length; j ++ ){
                    xb[xi++] = b[j];
                }
            }
            String str = null;
			try {
				str = new String(xb, ChatConstants.CHARSET);
			} catch (UnsupportedEncodingException e) {
				LOG.error(e.getMessage());
				str = "";
			}
            
            return str;
        }
        private int getTotalPackLength( ){ 
            int length = 0;
            for ( int i = 0; i < bytesList.size(); i ++ ){
                length += ((byte[]) bytesList.get(i)).length;
            }
            return length;
        }
        
		
		public Socket getSocket(){
			return socket;
		}
		
		
        public byte[] stringToByte(String str){
            try {
                return str.getBytes(ChatConstants.CHARSET);
            } catch (UnsupportedEncodingException ex) {
            	LOG.error(ex.getMessage());
            }
            return null;
        }    
        
        //先将服务器中所有此客户端的信息删除，再向此客户端发送信息，让它断线，全新登录
//        private void dropClient(String uid, String readStr){
//            try{
//    			for ( int i = 0; i < clientList.size(); i ++ ){
//                    ClientBean cb = clientList.get(i);
//                    if ( cb != null && cb.isFindUid(uid) ){
//                        clientList.remove(i); i --;
//                    }
//                }
//                for ( int i = 0; i < chatSocketList.size(); i ++ ){
//                    ClientChatThread c = (ClientChatThread) chatSocketList.get(i);
//                    if ( c != null && c.fromuserid != null && c.fromuserid.equals(uid) ){
//                        chatSocketList.remove(i); i --;
//                    }
//                }
//                sendToServer(readStr);//让客户端断线重新登录
//    		}catch(Exception e){
//    			LOG.error(e.toString(),e);
//    		}
//        }
        public void sendToClient(String content){
            try {
                if( myId == null || socket == null || socket.isClosed() ) return;
                byte[] bs = stringToByte(content + ChatConstants.END_TAG);
                bos.write(bs);
                bos.flush();
            }catch (Exception ex){
                LOG.error("===给客户端[" + myId + "]发送[" + content + "]时异常。");
                LOG.error(ex.toString(),ex);
                clientListener.quitOut(this);
            }
        }   
		
        
        /**
         * @Description:  发送文件
         * @author guoyr
         * @param fileName
         * @param sendId
         * @param receive
         */
        public void sendOfflineFileFromServerToClientThread(String order){
        	SendFileParam params = SendFileParam.getFileParams(order);
        	params.setSendIp(serverIp);
        	final ServerFileThread sendFileThread = new SendFileThread(params, myIpAddress, serverSendFileListener);
        	sendFileThread.start();
        	sendFileThreadList.add(sendFileThread); 
        }
        
        public int getThreadId(){
        	return threadId;
        }
        
        
        /**
         * @Description:  关闭服务器上的文件操作线程
         * @author guoyr
         * @param threadId
         */
        private void stopServerFileThread(long threadId){
        	int threadCount = sendFileThreadList.size();
        	if(threadCount > 0 && threadId > 0){
        		LOG.debug("销毁服务器的文件处理线程"+threadId + "总共"+ sendFileThreadList.size()+"个服务器线程");
        		for ( int i = 0; i < threadCount; i++ ){
        			ServerFileThread t = sendFileThreadList.get(i);
        			if (t.getThreadId() == threadId){
        				sendFileThreadList.remove(t); 
        				t.stop(); 
        				t.deleteFile();
        				t = null; 
        				i--;
        				break;
        			}
        			if(t.isStop()){
        				sendFileThreadList.remove(t); 
        				t = null;
        				i--;
        				continue;
        			}
        		}
        		LOG.debug("销毁服务器的文件处理线程"+threadId+"后，总数为"+sendFileThreadList.size());
        	}
        }
        
        /**
         * @Description:  创建服务器发送文件监听
         * @author guoyr
         */
        private void createServerSendFileListener(){
        	serverSendFileListener = new ServerSendFileListener(){
				public void removeServerFileThread(ServerFileThread sendFileThread) {
					for ( int i = 0; i < sendFileThreadList.size(); i++ ){
	        			ServerFileThread t = sendFileThreadList.get(i);
	        			if(t.getThreadId() == sendFileThread.getThreadId()){
	        				LOG.debug("销毁服务器的文件处理线程"+sendFileThread.getThreadId()+"后，总数为"+sendFileThreadList.size());
	        				sendFileThreadList.remove(t);
	        				i--;
	        				break;
	        			}
	        			if(t.isStop()){
	        				sendFileThreadList.remove(t);
	        				t = null;
	        				i--;
	        				continue;
	        			}
					}
				}
				public void sendOfflineFileRequest(String receiveId, String order) {
					clientListener.sendOfflineFileRequest(receiveId, order);
				}
        		
        	};
        }
        
        
        /**
         * @Description:  与服务器断开连接
         * @author guoyr
         */
        private void quitOutAction(){
        	// 通知服务器，我要退出连接
        	clientListener.quitOut(this);
        	// 同时中断所有的文件发送线程
        	for ( int i = 0; i < sendFileThreadList.size(); i++ ){
    			ServerFileThread t = sendFileThreadList.get(i);
    			t.stop();
    			sendFileThreadList.remove(t);
    			i--;
        	}
        }
    }
	
