package com.gx.obe.server.im.thread;


import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gx.obe.server.common.enumeration.CommonEnum;
import com.gx.obe.server.im.util.BeanContext;
import com.gx.obe.server.management.im.entity.MessageFile;
import com.gx.obe.server.management.im.service.MessageFileService;

public class SendFileCheck implements Runnable{
	private CheckOfflineFileListener listener;
	private Thread thread;
	private String myId;
 	private MessageFileService messageFileService = BeanContext.getApplicationContext().getBean(MessageFileService.class);;
	
	public SendFileCheck(String myId, CheckOfflineFileListener listener){
		this.listener = listener;
		this.myId = myId;
	}
	public void start(){
		thread = new Thread(this);
		thread.setName("检查是否存在离线文件要接收");
		thread.start();
	}
	
	public void stop(){
		
	}
        public void run(){
            try{
                if (null != thread){
                    Thread.sleep(2000);
                    QueryWrapper<MessageFile> queryWrapper = new QueryWrapper<MessageFile>();
                    queryWrapper.lambda().eq(MessageFile::getReadType, CommonEnum.NO).eq(MessageFile::getReceiveId, myId);
                    List<MessageFile> messageFileList = messageFileService.list(queryWrapper);
                    if (null != messageFileList && messageFileList.size() > 0){
                        //向服务器请求接收离线文件
                    	for(MessageFile file : messageFileList){
                    		listener.receive(file);
//                    		StringBuilder str = new StringBuilder();
//                    		str.append(OperatorUtil.CHANGE_SEND_OFFLINE_FILE);
//                    		str.append(FG);
//                    		str.append(file.getSendId());
//                    		str.append(FG);
//                    		str.append(Constants.CUR_EMPLOYEE.getObjId());
//                    		str.append(FG);
//                    		str.append(file.getFileName());
//                    		sendToServer(str.toString()); 
                             Thread.sleep(500);
                    	}
                    }
                }
            }catch(Exception e){
            }
        }
         public interface CheckOfflineFileListener{
        	 public void receive(MessageFile file);
         }
    }