package com.gx.obe.server.im.util;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import org.slf4j.Logger;

import com.gx.obe.server.common.utils.StringUtils;



public class IMPropertiesUtil {
	private static Map<String, String> enumMap = new HashMap<String, String>();
	private static Map<String, String> propertyMap = new HashMap<String, String>();
	private static Map<String, String> webserviceMap = new HashMap<String, String>();
	private static Properties properties;
	private static Logger LOG = org.slf4j.LoggerFactory.getLogger(IMPropertiesUtil.class);

	/**
	 * @Description:  获得配置文件的属性
	 * @author guoyr
	 * @param propertyName
	 * @param defaultpropertyValue
	 * @return
	 */
	public static String getProperty(String propertyName, String defaultpropertyValue){
		String propertyValue = propertyMap.get(propertyName);
		if(StringUtils.hasLength(propertyValue)){
			return propertyValue;
		}
		if(null == properties){
			InputStream in = null;
			properties = new Properties();
			try {
				in = IMPropertiesUtil.class.getResourceAsStream("/config.properties");
				properties.load(in);
			} catch (NullPointerException e) {
				in = IMPropertiesUtil.class.getResourceAsStream("/config.properties");
				try {
					properties.load(in);
				} catch (IOException e1) {
				}
				
			} catch (Exception e) {
				in = IMPropertiesUtil.class.getResourceAsStream("/config.properties");
				try {
					properties.load(in);
				} catch (IOException e1) {
				}
			}finally{
				if(null != in){
					try {
						in.close();
					} catch (IOException e) {
					}
					in = null;
				}
			}
		}
		
		propertyValue = properties.getProperty(propertyName,defaultpropertyValue);
		propertyMap.put(propertyName, propertyValue);
		return propertyValue;
	}
	
	/**
	 * @Description:  获得Properties
	 * @author guoyr
	 * @param propertieName
	 * @return
	 */
	public static Properties getProperties(String propertieName){
		Properties properties = new Properties();
		InputStream in = null;
		try {
			in = IMPropertiesUtil.class.getResourceAsStream("/"+propertieName);
			try {
				properties.load(in);
			} catch (IOException e1) {
			}
		}catch (NullPointerException e) {
			LOG.error(e.getMessage());
		} catch (Exception e) {
			LOG.error(e.getMessage());
		}finally{
			if(null != in){
				try {
					in.close();
				} catch (IOException e) {
				}
				in = null;
			}
			
		}
		return properties;
	}
	/**
	 * @Description:  获得Properties
	 * @author guoyr
	 * @param propertieName
	 * @return
	 */
	public static Properties getResourceAsStreamProperties(String propertieName){
		Properties properties = new Properties();
		InputStream in = null;
		try {
			in = IMPropertiesUtil.class.getResourceAsStream("/"+propertieName);
			try {
				properties.load(in);
			} catch (IOException e1) {
			}
		}catch (NullPointerException e) {
			LOG.error(e.getMessage());
		} catch (Exception e) {
			LOG.error(e.getMessage());
		}finally{
			if(null != in){
				try {
					in.close();
				} catch (IOException e) {
				}
				in = null;
			}
			
		}
		return properties;
	}
	
	/**
	 * @Description:  保存Properties
	 * @author guoyr
	 * @param properties
	 */
	public static void saveProperties(Properties properties, boolean...readLoadProperties){
		if(null != properties && StringUtils.isNotEmpty(properties.getProperty("properties_path"))){
			FileOutputStream fos;
			try {
				fos = new FileOutputStream(properties.getProperty("properties_path"));
				properties.store(fos, "update");
				fos.close();
			} catch (Exception e) {
				LOG.error(e.getMessage());
			}finally{
				boolean clean = true;
				if(null == readLoadProperties || readLoadProperties.length == 0){
					clean = true;
				}else {
					clean = readLoadProperties[0];
				}
				if(clean){
					enumMap.clear();
					propertyMap.clear();
					webserviceMap.clear();
				}
			}
		}
	}
}
