package com.gx.obe.server.management.boq.controller;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.boq.entity.ObeDayWorks;
import com.gx.obe.server.management.boq.service.ObeDayWorksService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Api(tags = "计日工")
@RestController
@AllArgsConstructor
@RequestMapping("/obeDayWorks")
public class ObeDayWorksController extends BaseController<ObeDayWorksService, ObeDayWorks> {
    @Autowired
    public ObeDayWorksService ObeDayWorksServices;

    /**
     * @param ObeDayWorksList
     * @Description: 批量插入
     * @author mazc
     */
    @PostMapping("/insertByBatch")
    public int insertByBatch(@RequestBody List<ObeDayWorks> ObeDayWorksList) {
        return ObeDayWorksServices.insertByBatch(ObeDayWorksList);
    }

    /**
     * @param ObeDayWorksList
     * @Description: 批量更新
     * @author mazc
     */
    @PostMapping("/updateByBatch")
    public int updateByBatch(@RequestBody List<ObeDayWorks> ObeDayWorksList) {
        return ObeDayWorksServices.updateByBatch(ObeDayWorksList);
    }

    /**
     * @param projectId
     * @return DayWorks
     * @Description: 根据工程Id，获得计日工信息。
     * @author guoyr
     */
    @GetMapping("/getDayWorksListByProjectId")
    public List<ObeDayWorks> getDayWorksListByProjectId(String projectId) {
        return ObeDayWorksServices.getDayWorksListByProjectId(projectId);
    }

}