package com.gx.obe.server.management.boq.controller;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.boq.entity.ObeSupplyMaterialDetail;
import com.gx.obe.server.management.boq.service.ObeSupplyMaterialDetailService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/obeSupplyMaterialDetail")
public class ObeSupplyMaterialDetailController extends BaseController<ObeSupplyMaterialDetailService, ObeSupplyMaterialDetail> {
    @Autowired
    public ObeSupplyMaterialDetailService ObeSupplyMaterialDetailServices;

    /**
     * @param ObeSupplyMaterialDetailList
     * @Description: 批量插入
     * @author mazc
     */
    @PostMapping("/insertByBatch")
    public int insertByBatch(@RequestBody List<ObeSupplyMaterialDetail> ObeSupplyMaterialDetailList) {
        return ObeSupplyMaterialDetailServices.insertByBatch(ObeSupplyMaterialDetailList);
    }

    /**
     * @param ObeSupplyMaterialDetailList
     * @Description: 批量更新
     * @author mazc
     */
    @PostMapping("/updateByBatch")
    public int updateByBatch(@RequestBody List<ObeSupplyMaterialDetail> ObeSupplyMaterialDetailList) {
        return ObeSupplyMaterialDetailServices.updateByBatch(ObeSupplyMaterialDetailList);
    }

    /**
     * @param projectId
     * @return
     * @Description: 根据工程项目id获取招标人供应材料设备明细列表
     * @author chenxw
     */
    @GetMapping("/getSupplyMaterialDetailListByProjectId")
    public List<ObeSupplyMaterialDetail> getSupplyMaterialDetailListByProjectId(String projectId) {
        return ObeSupplyMaterialDetailServices.getSupplyMaterialDetailListByProjectId(projectId);
    }

}