package com.gx.obe.server.management.boq.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.boq.entity.ObeBillTable;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeBillTableMapper extends BaseMapper<ObeBillTable> {

    /**
     * @param ObeBillTableList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeBillTableList") List<ObeBillTable> ObeBillTableList);

    /**
     * @param ObeBillTableList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeBillTableList") List<ObeBillTable> ObeBillTableList);

    /**
     * @param ObeBillTable
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeBillTable") ObeBillTable ObeBillTable, @Param("attributes") String[] attributes);

    /**
     * @param ObeBillTableList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeBillTableList") List<ObeBillTable> ObeBillTableList, @Param("attributes") String[] attributes);

    /**
     * @param tenderId
     * @return
     * @Description 根据项目ID删除数据
     */
    Integer deleteByTenderId(@Param("tenderId") String tenderId);

    /**
     * @param tenderId
     * @param supplierId
     * @return
     * @Description: 获得供应商全部分布分项的清单列表
     */
    List<ObeBillTable> getAllBillTableQDList(@Param("tenderId") String tenderId, @Param("supplierId") String supplierId);

    /**
     * @param tenderId
     * @param projectCode
     * @return
     * @Description: 获得招标项目的分布分项的清单列表
     * @author guoyr
     */
    List<ObeBillTable> getTenderProjectBillTableQdList(@Param("tenderId") String tenderId, @Param("projectCode") String projectCode);

    /**
     * @param projectId
     * @return
     * @Description: 获得分布分项的清单列表
     * @author guoyr
     */
    List<ObeBillTable> getBillTableQdList(@Param("projectId") String projectId);

    /**
     * @param projectId 单位工程编号
     * @return List<BillTable>
     * @Description: 根据工程项目编号"，获得分部分项信息(分布工程、清单、定额、工料机)
     * @author guoyr
     */
    List<ObeBillTable> getBillTableList(@Param("projectId") String projectId);

    /**
     * @param constructionIds
     * @return
     * @Description: 获得供应商全部分布分项的清单列表
     * @author mazc
     */
    List<ObeBillTable> getBillTableBTConstructionIdsList(@Param("constructionIds") List<String> constructionIds);

    /**
     * @param projectId
     * @return
     * @Description: 获得分布分项的清单和定额列表
     * @author guoyr
     */
    List<ObeBillTable> getBillTableQdAndDeList(@Param("projectId") String projectId);

}