package com.gx.obe.server.management.boq.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.boq.entity.ObeDayWorks;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeDayWorksMapper extends BaseMapper<ObeDayWorks> {

    /**
     * @param ObeDayWorksList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeDayWorksList") List<ObeDayWorks> ObeDayWorksList);

    /**
     * @param ObeDayWorksList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeDayWorksList") List<ObeDayWorks> ObeDayWorksList);

    /**
     * @param ObeDayWorks
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeDayWorks") ObeDayWorks ObeDayWorks, @Param("attributes") String[] attributes);

    /**
     * @param ObeDayWorksList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeDayWorksList") List<ObeDayWorks> ObeDayWorksList, @Param("attributes") String[] attributes);

    /**
     * @param tenderId
     * @return
     * @Description 根据项目ID删除数据
     */
    Integer deleteByTenderId(@Param("tenderId") String tenderId);

    /**
     * @param projectId
     * @return List<DayWorks>
     * @Description: 根据工程Id，获得计日工信息。
     * @author guoyr
     */
    List<ObeDayWorks> getDayWorksListByProjectId(@Param("projectId") String projectId);

}