package com.gx.obe.server.management.boq.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Mapper;
import com.gx.obe.server.management.boq.entity.ObeProvisionalSums;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Mapper
public interface ObeProvisionalSumsMapper extends BaseMapper<ObeProvisionalSums> {

    /**
     * @param ObeProvisionalSumsList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateBatchList(@Param("ObeProvisionalSumsList") List<ObeProvisionalSums> ObeProvisionalSumsList);

    /**
     * @param ObeProvisionalSumsList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(@Param("ObeProvisionalSumsList") List<ObeProvisionalSums> ObeProvisionalSumsList);

    /**
     * @param ObeProvisionalSums
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    Integer updateAssignProperty(@Param("ObeProvisionalSums") ObeProvisionalSums ObeProvisionalSums, @Param("attributes") String[] attributes);

    /**
     * @param ObeProvisionalSumsList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(@Param("ObeProvisionalSumsList") List<ObeProvisionalSums> ObeProvisionalSumsList, @Param("attributes") String[] attributes);

    /**
     * @param tenderId
     * @return
     * @Description 根据项目ID删除数据
     */
    Integer deleteByTenderId(@Param("tenderId") String tenderId);

    /**
     * @param projectId
     * @return List<ProvisionalSums>
     * @Description: 根据工程Id，获得暂列金额
     * @author guoyr
     */
    List<ObeProvisionalSums> getProvisionalSumsListByProjectId(@Param("projectId") String projectId);

}