package com.gx.obe.server.management.boq.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonBackReference;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Data
@TableName("obe_construct_project")
public class ObeConstructProject extends Model<ObeConstructProject> {

    private static final long serialVersionUID = 1L;

    /**
     * 项目工程主键，唯一标识。
     */
    @TableId("CONSTRUCT_PROJECT_ID")
    private String id;
    /**
     * 项目或工程编号
     */
    @TableField("PROJECT_CODE")
    private String projectCode;
    /**
     * 项目或工程名称
     */
    @TableField("PROJECT_NAME")
    private String projectName;
    /**
     * 项目工程父ID
     */
    @TableField("PARENT_ID")
    private String parentId;
    /**
     * 标段
     */
    @TableField("SEGMENT")
    private String segment;
    /**
     * 建设规模
     */
    @TableField("SCALE")
    private BigDecimal scale;
    /**
     * 规模单位
     */
    @TableField("SCALE_UNIT")
    private String scaleUnit;
    /**
     * 计价专业
     */
    @TableField("ACCORDINGAS")
    private String accordingas;
    /**
     * 清单库
     */
    @TableField("BILL_DATA_BASE")
    private String billDataBase;
    /**
     * 定额库
     */
    @TableField("NORM_DATA_BASE")
    private String normDataBase;
    /**
     * 计价规则
     */
    @TableField("JJGZ")
    private String jjgz;
    /**
     * 计价方式(0：定额计价；1：清单计价)
     */
    @TableField("IS_QD")
    private String isQd;
    /**
     * 合价或金额（元）
     */
    @TableField("TOTAL")
    private BigDecimal total;
    /**
     * 暂估价
     */
    @TableField("ZGJ")
    private BigDecimal zgj;
    /**
     * 安全文明施工费
     */
    @TableField("SAFE_FEE")
    private BigDecimal safeFee;
    /**
     * 规费
     */
    @TableField("GFEE")
    private BigDecimal gfee;
    /**
     * 版本
     */
    @TableField("PROJECT_VERSION")
    private String projectVersion;
    /**
     * XML标准名称
     */
    @TableField("XML_BZ")
    private String xmlBz;
    /**
     * 专业(01：建筑；02：装饰；03：安装；04：市政；05：园林)
     */
    @TableField("SPECIALTY")
    private String specialty;
    /**
     * 占整个项目费用比率（%）
     */
    @TableField("RATIOS")
    private BigDecimal ratios;
    /**
     * 备注
     */
    @TableField("REMARK")
    private String remark;
    /**
     * 招标项目外键Id
     */
    @TableField("TENDER_ID")
    private String tenderId;
    /**
     * 供应Id
     */
    @TableField("SUPPLIER_ID")
    private String supplierId;
    /**
     * 工程类型(01：工程项目；02：单项工程；03：单位工程)
     */
    @TableField("KIND")
    private String kind;
    /**
     * 序号
     */
    @TableField("SORT_NO")
    private Integer sortNo;
    /**
     * 建筑面积
     */
    @TableField("FLOORAGE")
    private BigDecimal floorage;
    /**
     * 税前工程造价
     */
    @TableField("PRE_TAX_COST")
    private BigDecimal preTaxCost;
    /**
     * 进项税额
     */
    @TableField("INPUT_TAX")
    private BigDecimal inputTax;
    /**
     * 销项税额
     */
    @TableField("OUTPUT_TAX")
    private BigDecimal outputTax;
    /**
     * 增值税应纳税额
     */
    @TableField("VALUE_ADDED_TAX")
    private BigDecimal valueAddedTax;
    /**
     * 附加税费
     */
    @TableField("SURCHARGE_TAX")
    private BigDecimal surchargeTax;
    /**
     * 税金
     */
    @TableField("TAXES")
    private BigDecimal taxes;
    /**
     * 附加税费费率
     */
    @TableField("SURCHARGE_TAX_RATE")
    private BigDecimal surchargeTaxRate;
    /**
     * 其他项
     */
    @TableField("QTX")
    private BigDecimal qtx;
    /**
     * 设备费
     */
    @TableField("EQUIPMENT")
    private BigDecimal equipment;
    /**
     * 税金
     */
    @TableField("TAX")
    private BigDecimal tax;
    /**
     * 分部分项
     */
    @TableField("FBFX")
    private BigDecimal fbfx;
    /**
     * 措施项
     */
    @TableField("CSX")
    private BigDecimal csx;
    /**
     * 总价措施项
     */
    @TableField("TOTALCSX")
    private BigDecimal totalcsx;
    /**
     * 单价措施项
     */
    @TableField("SINGLECSX")
    private BigDecimal singlecsx;
    /**
     * 暂列金额
     */
    @TableField("ZLJ")
    private BigDecimal zlj;

    @TableField(exist = false)
    @JsonBackReference
    private ObeConstructProject parentProject;

    @TableField(exist = false)
    @JsonManagedReference
    private List<ObeConstructProject> childProjectList = new ArrayList<>();

    public void addChild(ObeConstructProject childProject) {
        if (null == childProjectList) {
            childProjectList = new ArrayList<>();
        }
        childProjectList.add(childProject);
    }

    public static final String CONSTRUCT_PROJECT_ID = "CONSTRUCT_PROJECT_ID";

    public static final String PROJECT_CODE = "PROJECT_CODE";

    public static final String PROJECT_NAME = "PROJECT_NAME";

    public static final String PARENT_ID = "PARENT_ID";

    public static final String SEGMENT = "SEGMENT";

    public static final String SCALE = "SCALE";

    public static final String SCALE_UNIT = "SCALE_UNIT";

    public static final String ACCORDINGAS = "ACCORDINGAS";

    public static final String BILL_DATA_BASE = "BILL_DATA_BASE";

    public static final String NORM_DATA_BASE = "NORM_DATA_BASE";

    public static final String JJGZ = "JJGZ";

    public static final String IS_QD = "IS_QD";

    public static final String TOTAL = "TOTAL";

    public static final String ZGJ = "ZGJ";

    public static final String SAFE_FEE = "SAFE_FEE";

    public static final String GFEE = "GFEE";

    public static final String PROJECT_VERSION = "PROJECT_VERSION";

    public static final String XML_BZ = "XML_BZ";

    public static final String SPECIALTY = "SPECIALTY";

    public static final String RATIOS = "RATIOS";

    public static final String REMARK = "REMARK";

    public static final String TENDER_ID = "TENDER_ID";

    public static final String SUPPLIER_ID = "SUPPLIER_ID";

    public static final String KIND = "KIND";

    public static final String SORT_NO = "SORT_NO";

    public static final String FLOORAGE = "FLOORAGE";

    public static final String PRE_TAX_COST = "PRE_TAX_COST";

    public static final String INPUT_TAX = "INPUT_TAX";

    public static final String OUTPUT_TAX = "OUTPUT_TAX";

    public static final String VALUE_ADDED_TAX = "VALUE_ADDED_TAX";

    public static final String SURCHARGE_TAX = "SURCHARGE_TAX";

    public static final String TAXES = "TAXES";

    public static final String SURCHARGE_TAX_RATE = "SURCHARGE_TAX_RATE";

    public static final String QTX = "QTX";

    public static final String EQUIPMENT = "EQUIPMENT";

    public static final String TAX = "TAX";

    public static final String FBFX = "FBFX";

    public static final String CSX = "CSX";

    public static final String TOTALCSX = "TOTALCSX";

    public static final String SINGLECSX = "SINGLECSX";

    public static final String ZLJ = "ZLJ";

}