package com.gx.obe.server.management.boq.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @author mazc
 * @Description:
 */
@Data
@TableName("obe_day_works")
public class ObeDayWorks extends Model<ObeDayWorks> {

    private static final long serialVersionUID = 1L;

    /**
     * 计日工主键，唯一标识。
     */
    @TableId("DAY_WORKS_ID")
    private String id;
    /**
     * 计日工父ID
     */
    @TableField("PARENT_ID")
    private String parentId;
    /**
     * 序号
     */
    @TableField("ORD_CODE")
    private String ordCode;
    /**
     * 名称
     */
    @TableField("WORKS_NAME")
    private String worksName;
    /**
     * 单位
     */
    @TableField("UNIT")
    private String unit;
    /**
     * 数量
     */
    @TableField("QTY")
    private BigDecimal qty;
    /**
     * 单价
     */
    @TableField("PRICE")
    private BigDecimal price;
    /**
     * 金额(元)
     */
    @TableField("TOTAL")
    private BigDecimal total;
    /**
     * 类型(00：计日工 pid=’’时；01：人工费；02：材料费；03：机械费)
     */
    @TableField("KIND")
    private String kind;
    /**
     * 备注
     */
    @TableField("REMARK")
    private String remark;
    /**
     * 工程项目外键Id
     */
    @TableField("PROJECT_ID")
    private String projectId;
    /**
     * 序号
     */
    @TableField("SORT_NO")
    private Integer sortNo;
    /**
     * 招标项目外键Id
     */
    @TableField("TENDER_ID")
    private String tenderId;
    /**
     * 供应商Id
     */
    @TableField("SUPPLIER_ID")
    private String supplierId;
    /**
     * 序号
     */
    @TableField("NUMBER")
    private String number;

    public static final String DAY_WORKS_ID = "DAY_WORKS_ID";

    public static final String PARENT_ID = "PARENT_ID";

    public static final String ORD_CODE = "ORD_CODE";

    public static final String WORKS_NAME = "WORKS_NAME";

    public static final String UNIT = "UNIT";

    public static final String QTY = "QTY";

    public static final String PRICE = "PRICE";

    public static final String TOTAL = "TOTAL";

    public static final String KIND = "KIND";

    public static final String REMARK = "REMARK";

    public static final String PROJECT_ID = "PROJECT_ID";

    public static final String SORT_NO = "SORT_NO";

    public static final String TENDER_ID = "TENDER_ID";

    public static final String SUPPLIER_ID = "SUPPLIER_ID";

    public static final String NUMBER = "NUMBER";

}