package com.gx.obe.server.management.boq.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @author mazc
 * @Description:
 */
@Data
@TableName("obe_project_summary")
public class ObeProjectSummary extends Model<ObeProjectSummary> {

    private static final long serialVersionUID = 1L;

    /**
     * 项目费用汇总明细主键，唯一标识。
     */
    @TableId("PROJECT_SUMMARY_ID")
    private String id;
    /**
     * 项目费用汇总明父ID
     */
    @TableField("PARENT_ID")
    private String parentId;
    /**
     * 代号
     */
    @TableField("SUMMARY_CODE")
    private String summaryCode;
    /**
     * 费用名称
     */
    @TableField("SUMMARY_NAME")
    private String summaryName;
    /**
     * 汇总类型
     */
    @TableField("KIND")
    private String kind;
    /**
     * 计算基数
     */
    @TableField("FORMULA")
    private String formula;
    /**
     * 费率（%）
     */
    @TableField("RATE")
    private BigDecimal rate;
    /**
     * 金额（元）
     */
    @TableField("TOTAL")
    private BigDecimal total;
    /**
     * 备注
     */
    @TableField("REMARK")
    private String remark;
    /**
     * 是否总计
     */
    @TableField("IS_TOTAL")
    private Boolean isTotal;
    /**
     * 工程项目外键Id
     */
    @TableField("PROJECT_ID")
    private String projectId;
    /**
     * 招标项目外键Id
     */
    @TableField("TENDER_ID")
    private String tenderId;
    /**
     * 供应商Id
     */
    @TableField("SUPPLIER_ID")
    private String supplierId;
    /**
     * 安全文明施工费(元)
     */
    @TableField("SAFE_FEE")
    private BigDecimal safeFee;
    /**
     * 规费(元)
     */
    @TableField("GFEE")
    private BigDecimal gfee;
    /**
     * 暂估价(元)
     */
    @TableField("ZGJ")
    private BigDecimal zgj;
    /**
     * 序号
     */
    @TableField("SORT_NO")
    private Integer sortNo;
    /**
     * 人工费
     */
    @TableField("RFEE")
    private BigDecimal rfee;
    /**
     * 材料费
     */
    @TableField("CFEE")
    private BigDecimal cfee;
    /**
     * 机械费
     */
    @TableField("JFEE")
    private BigDecimal jfee;
    /**
     * 序号
     */
    @TableField("NUMBER")
    private String number;

    public static final String PROJECT_SUMMARY_ID = "PROJECT_SUMMARY_ID";

    public static final String PARENT_ID = "PARENT_ID";

    public static final String SUMMARY_CODE = "SUMMARY_CODE";

    public static final String SUMMARY_NAME = "SUMMARY_NAME";

    public static final String KIND = "KIND";

    public static final String FORMULA = "FORMULA";

    public static final String RATE = "RATE";

    public static final String TOTAL = "TOTAL";

    public static final String REMARK = "REMARK";

    public static final String IS_TOTAL = "IS_TOTAL";

    public static final String PROJECT_ID = "PROJECT_ID";

    public static final String TENDER_ID = "TENDER_ID";

    public static final String SUPPLIER_ID = "SUPPLIER_ID";

    public static final String SAFE_FEE = "SAFE_FEE";

    public static final String GFEE = "GFEE";

    public static final String ZGJ = "ZGJ";

    public static final String SORT_NO = "SORT_NO";

    public static final String RFEE = "RFEE";

    public static final String CFEE = "CFEE";

    public static final String JFEE = "JFEE";

    public static final String NUMBER = "NUMBER";

}