package com.gx.obe.server.management.boq.service;

import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

import com.gx.obe.server.management.boq.entity.ObeProjectSummary;

/**
 * @author mazc
 * @Description:
 */
public interface ObeProjectSummaryService extends IService<ObeProjectSummary> {

    /**
     * @param ObeProjectSummaryList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeProjectSummary> ObeProjectSummaryList);

    /**
     * @param ObeProjectSummaryList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeProjectSummary> ObeProjectSummaryList);

    /**
     * @param ObeProjectSummary
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeProjectSummary ObeProjectSummary, String[] attributes);

    /**
     * @param ObeProjectSummaryList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeProjectSummary> ObeProjectSummaryList, String[] attributes);

    /**
     * @param ObeProjectSummaryList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeProjectSummary> ObeProjectSummaryList, String[] attributes);

    /**
     * @param projectId
     * @return
     * @Description: 获得项目的汇总列表
     * @author guoyr
     */
    List<ObeProjectSummary> getProjectSummaryAndChildList(String projectId);

}



