package com.gx.obe.server.management.boq.service;

import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

import com.gx.obe.server.management.boq.entity.ObeQuotaItem;

/**
 * @author mazc
 * @Description:
 */
public interface ObeQuotaItemService extends IService<ObeQuotaItem> {

    /**
     * @param ObeQuotaItemList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeQuotaItem> ObeQuotaItemList);

    /**
     * @param ObeQuotaItemList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeQuotaItem> ObeQuotaItemList);

    /**
     * @param ObeQuotaItem
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeQuotaItem ObeQuotaItem, String[] attributes);

    /**
     * @param ObeQuotaItemList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeQuotaItem> ObeQuotaItemList, String[] attributes);

    /**
     * @param ObeQuotaItemList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeQuotaItem> ObeQuotaItemList, String[] attributes);

    /**
     * @param billId
     * @return
     * @Description: 获得清单的定额列表
     */
    List<ObeQuotaItem> getBillQuotaItemList(String billId);

}



