package com.gx.obe.server.management.check.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.check.entity.CheckResult;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface CheckResultService extends IService<CheckResult> {
 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeCheckResultList 
	 */
 	Integer updateByBatch (List<CheckResult> ObeCheckResultList);
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeCheckResultList 
	 */
	Integer insertByBatch (List<CheckResult> ObeCheckResultList);
	
	
	
	/** 
	 * @Description: 删除清标检查结果
	 * @author mazc
	 * @param tenderId 项目id
	 * @return 
	 */
	int deleteStepByTenderId(String tenderId);
	
	int saveBoqCheckResult(String tenderId, String userId, String checkItemId, List<CheckResult> checkResultList);
	
	
	/**
	 * @Description: 根据条件查询数量
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param checkItemId
	 * @return 
	 */
	int getQueryCount(String tenderId,String userId,String checkItemId);
	
	
	/**
	 * @Description: 条件查询
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param supplierId
	 * @param checkItemId
	 * @param stepId
	 * @return 
	 */
	CheckResult getCheckResultByCondition(String tenderId,String userId,String supplierId ,String checkItemId,String stepId);
	/**
	 * @Description:删除评审记录结果 
	 * @author wangxiang
	 * @param tenderId
	 * @param id 
	 */
	int deleteCheckResult(String tenderId, String stepId);

	/**
	 * @Description: 获取清单检查结果
	 * @author mazc
	 * @param tenderId
	 * @param checkItemId
	 * @param supplierIds
	 * @return
	 */
	List<CheckResult> getCheckResultByDictionaryValueId(String tenderId, String checkItemId, List<String> supplierIds);

}



