package com.gx.obe.server.management.config.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.config.entity.SysConfig;
import com.gx.obe.server.management.config.entity.SysConfigValue;

/** 
 * @Description: 
 * @author mazc 
 */
@Mapper
public interface SysConfigMapper extends BaseMapper<SysConfig> {

	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param SysConfigList 
	 */
	public int updateBatchList(@Param("SysConfigList") List<SysConfig> SysConfigList);
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param SysConfigList 
	 */
	public int insertByBatch(@Param("SysConfigList") List<SysConfig> SysConfigList);

	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param SysConfig
	 * @param attributes
     */
    public int updateAssignProperty(@Param("SysConfig")SysConfig SysConfig, @Param("attributes")String[] attributes);
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param SysConfigList
	 * @param attributes
     */
    public int batchUpdateProperty(@Param("SysConfigList")List<SysConfig> SysConfigList, @Param("attributes")String[] attributes);
    

	/**
	 * @Description: 验证配置名称唯一性
	 * @author mazc
	 * @param id
	 * @param configName
	 * @return 
	 */
    public int isUniqueConfigName(@Param("id")String id, @Param("configName")String configName);
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param id
	 * @param configCode
	 * @return 
	 */
	public int isUniqueConfigCode(@Param("id")String id, @Param("configCode")String configCode);
	
	public SysConfig getConfigByCode(@Param("configCode")String configCode);
	
	/**
	  * @Description: 根据配置编码，获得有效配置值集合。
	  * @author mazc
	  * @param dictCode 配置编码
	  * @return List<SysConfigValue>
	  */
	public List<SysConfigValue> getConfigValueList(@Param("configCode") String configCode);



}