package com.gx.obe.server.management.dictionary.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.dictionary.entity.Supervise;
import com.gx.obe.server.management.dictionary.service.SuperviseService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "监督人")
@RestController
@AllArgsConstructor
@RequestMapping("/supervise")
public class SuperviseController extends BaseController<SuperviseService,Supervise>{
	@Autowired
	public SuperviseService uperviseServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param obeSuperviseList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<Supervise> obeSuperviseList) {
		return uperviseServices.insertByBatch(obeSuperviseList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param obeSuperviseList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<Supervise> obeSuperviseList) {
		return uperviseServices.updateByBatch(obeSuperviseList);
	}

	
	/**
	 * @Description: 查询监督人列表
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	@GetMapping("/getSuperviseList")
	public List<Supervise> getSuperviseList(String tenderId){
		return uperviseServices.getSuperviseList(tenderId);
	}
	
	/**
	 * @Description: 删除监督人
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @return 
	 */
	@GetMapping("/deleteSupervise")
	public boolean deleteSupervise(String tenderId, String userId){
		return uperviseServices.deleteSupervise(tenderId, userId);
	}
	
	@GetMapping("/getSuperviseIdByTenderIdOrUserId")
	public List<Object> getSuperviseIdByTenderIdOrUserId(String tenderId,String userId){
		return uperviseServices.getSuperviseIdByTenderIdOrUserId(tenderId, userId);
	}
}