package com.gx.obe.server.management.dictionary.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.dictionary.entity.TransactionServerEntity;

import java.util.List;
/** 
 * @Description: 
 * @author mazc 
 */
 @Mapper
public interface TransactionServerMapper extends BaseMapper<TransactionServerEntity> {

	Integer updateObeTransactionServerBatchList (List<TransactionServerEntity> ObeTransactionServerList);
	
	
	/**
	 * @Description: 获得执行交易系统的最大序号
	 * @author mazc
	 * @return 
	 */
	int getMaxTransactionServerSortNo();

	
	/**
	 * @Description: 获得当前平台的服务信息
	 * @author mazc
	 * @param serName
	 * @param serverAddress
	 * @return 
	 */
	TransactionServerEntity getCurPlatformTransactionServer(@Param("serName")String serName,@Param("serverAddress") String serverAddress);

	/**
	 * @Description: 获得指定状态的服务
	 * @author wangxiang
	 * @param realStatus
	 * @return 
	 */
	List<TransactionServerEntity> getStatusServer(String realStatus);
	
	
}