package com.gx.obe.server.management.dictionary.service;

import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.dictionary.entity.Machine;
import com.gx.obe.server.management.vo.Condition;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface MachineService extends IService<Machine> {
 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeMachineList 
	 */
 	Integer updateByBatch (List<Machine> ObeMachineList);
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeMachineList 
	 */
	Integer insertByBatch (List<Machine> ObeMachineList);
	
	
	
	/**
	 * @Description: 获得评标机位集合
	 * @author mazc
	 * @param tenderId 项目ID
	 * @param isUsed 是否使用
	 * @param machineType 类型
	 * @return List<Machine>
	 */
	public List<Machine> getProjectMachineList(String tenderId, String isUsed, String machineType);
	
	/**
	 * @Description: 获得当前项目下已登录的机位
	 * @author mazc
	 * @param tenderId 项目
	 * @param loginTime 登录时间
	 * @return
	 */
	public List<Machine> getProjectLoginedMachineList(String tenderId, Date loginTime);
	
	/**
	 * @Description: 获得指定评标室内的机位列表
	 * @author mazc
	 * @param roomeId
	 * @return
	 */
	public List<Machine> getEvaluationRoomMachineList(String roomeId);
	
	/**
	 * @Description: 批量保存已申请机位信息
	 * @author mazc
	 * @param list
	 * @return
	 */
	public int saveMachineList(List<Machine> list);
	
	/** 
	 * @Description: 删除评标室的机位
	 * @author mazc
	 * @param roomId
	 * @return 
	 */
	public int deleteEvaluationRoomMachine(String roomId);

	/**
	 * @Description: 
	 * @author mazc
	 * @param machineMac
	 * @param machineIp
	 * @param useStatus
	 * @return 
	 */
	List<Object> isExist(String machineMac ,String machineIp,String useStatus);
	
	
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param machine
	 * @return 
	 */
	Machine saveOrUpdateReturn(Machine machine);
	
	List<Object> getEvalRoomIdByMachineMacAndUseStatus(String machineMac, String useStatus);
	
	
	List<Machine> getMachineByUseStatusAndOrderby(String useStatus);
	
	
	Machine getMachineByMacOrNotEQ(String machineMac,String id);
	int updateCondition(Condition condition);
	List<Object> getEvalRoomIdByMachineNameAndEvalRoomId(String machineName, String evalRoomId,String id);
}



