package com.gx.obe.server.management.dictionary.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.dictionary.entity.ProjectTemplate;

import java.util.Date;
import java.util.List;

/**
 * @author mazc
 * @Description:
 */
public interface ProjectTemplateService extends IService<ProjectTemplate> {

	/**
	 * @param ObeProjectTemplateList
	 * @Description: 批量更新
	 * @author mazc
	 */
	Integer updateByBatch(List<ProjectTemplate> ObeProjectTemplateList);

	/**
	 * @param ObeProjectTemplateList
	 * @Description: 批量插入
	 * @author mazc
	 */
	Integer insertByBatch(List<ProjectTemplate> ObeProjectTemplateList);

	/**
	 * @param ObeProjectTemplate
	 * @param attributes
	 * @Description: 指定字段修改
	 * @author chenxw
	 */
	boolean updateAssignProperty(ProjectTemplate ObeProjectTemplate, String[] attributes);

	/**
	 * @param ObeProjectTemplateList
	 * @param attributes
	 * @Description: 批量指定字段修改
	 * @author chenxw
	 */
	Integer batchUpdateProperty(List<ProjectTemplate> ObeProjectTemplateList, String[] attributes);

	/**
	 * @param ObeProjectTemplateList
	 * @param attributes
	 * @return
	 * @Description: 批量添加或跟新
	 * @author chenxw
	 */
	Integer batchSaveOrUpdate(List<ProjectTemplate> ObeProjectTemplateList, String[] attributes);

	/**
	 * @Description: 获取所有模板
	 * @author chenxw
	 * @return
	 */
	List<ProjectTemplate> getAllList();

	/**
	 * @Description: 根据项目id及模板类型获取列表
	 * @author chenxw
	 * @param tenderId
	 * @param templateType
	 * @return
	 */
	List<ProjectTemplate> getListByTenderIdAndTemplateType(String tenderId, String templateType);

	/**
	 * @Description: 删除项目模板
	 * @author chenxw
	 * @param projectTemplate
	 * @return
	 */
	boolean deleteProjectTemplate(ProjectTemplate projectTemplate);

	/**
	 * @Description: 获取最晚修改时间
	 * @author chenxw
	 * @return
	 */
    Date getLatestModifyTime();

}



