package com.gx.obe.server.management.dictionary.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.dictionary.entity.TorrentFile;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface TorrentFileService extends IService<TorrentFile> {
 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeTorrentFileList 
	 */
 	Integer updateByBatch (List<TorrentFile> ObeTorrentFileList);
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeTorrentFileList 
	 */
	Integer insertByBatch (List<TorrentFile> ObeTorrentFileList);
	
	
	 /**
	 * @Description: 通过主键删除
	 * @author mazc
	 * @param uTorrentFileId
	 * @return 
	 */
	int deleteTorrentFileById(List<String> uTorrentFileId);
	
	
	/**
	 * @Description: 获取项目经理所拥有的项目的种子文件
	 * @author mazc
	 * @param userId
	 * @return 
	 */
	List<TorrentFile> getTorrentFileListByManager(String userId);
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	TorrentFile getTorrentFileByTenderId(String tenderId);
	
	
	 /**
	 * @Description: 
	 * @author mazc
	 * @return 
	 */
	List<TorrentFile> getTorrentFileAllOrderByFileName();
	
	
	/**
	 * @Description: 保存或更新
	 * @author mazc
	 * @param workMemberList
	 * @return 
	 */
	int batchSaveOrUpdate(List<TorrentFile> workMemberList);
	
}



