package com.gx.obe.server.management.evaluation.entity;

import java.io.Serializable;
import java.util.Date;

import org.springframework.format.annotation.DateTimeFormat;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description:
 * @author mazc
 */

@TableName("obe_evaluation_report")
public class EvaluationReport extends Model<EvaluationReport> {
	private static final long serialVersionUID = 1L;

	/**
	 * 模板主键
	 */
	@TableId("REPORT_ID")
	private String id;
	/**
	 * 模板名称
	 */
	@TableField("REPORT_NAME")
	private String reportName;
	/**
	 * 项目id
	 */
	@TableField("TENDER_ID")
	private String tenderId;
	/**
	 * 用户id
	 */
	@TableField("USER_ID")
	private String userId;
	/**
	 * 步骤id
	 */
	@TableField("STEP_ID")
	private String stepId;
	/**
	 * 报表字节
	 */
	@TableField("REPORT_BYTE")
	private byte[] reportByte;
	/**
	 * 报表类型
	 */
	@TableField("REPORT_TYPE")
	private String reportType;
	/**
	 * 创建日期
	 */
	@TableField("MODIFY_TIME")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date modifyTime;

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getReportName() {
		return reportName;
	}

	public void setReportName(String reportName) {
		this.reportName = reportName;
	}

	public String getTenderId() {
		return tenderId;
	}

	public void setTenderId(String tenderId) {
		this.tenderId = tenderId;
	}

	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	public String getStepId() {
		return stepId;
	}

	public void setStepId(String stepId) {
		this.stepId = stepId;
	}

	public byte[] getReportByte() {
		return reportByte;
	}

	public void setReportByte(byte[] reportByte) {
		this.reportByte = reportByte;
	}

	public String getReportType() {
		return reportType;
	}

	public void setReportType(String reportType) {
		this.reportType = reportType;
	}

	public Date getModifyTime() {
		return modifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		this.modifyTime = modifyTime;
	}

	public static final String REPORT_ID = "REPORT_ID";

	public static final String REPORT_NAME = "REPORT_NAME";

	public static final String TENDER_ID = "TENDER_ID";

	public static final String USER_ID = "USER_ID";

	public static final String STEP_ID = "STEP_ID";

	public static final String REPORT_BYTE = "REPORT_BYTE";

	public static final String REPORT_TYPE = "REPORT_TYPE";

	public static final String MODIFY_TIME = "MODIFY_TIME";

	@Override
	protected Serializable pkVal() {
		return this.id;
	}

	@Override
	public String toString() {
		return "EvaluationReport{" + ", id=" + id + ", reportName=" + reportName + ", tenderId=" + tenderId
				+ ", userId=" + userId + ", stepId=" + stepId + ", reportByte=" + reportByte + ", reportType="
				+ reportType + ", modifyTime=" + modifyTime + "}";
	}
}
