package com.gx.obe.server.management.evaluation.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.evaluation.entity.BidPriceHisResult;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @author mazc
 * @Description:
 */
public interface BidPriceHisResultService extends IService<BidPriceHisResult> {
    /**
     * @param ObeBidPriceHisResultList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<BidPriceHisResult> ObeBidPriceHisResultList);

    /**
     * @param ObeBidPriceHisResultList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<BidPriceHisResult> ObeBidPriceHisResultList);


    /**
     * @param tenderID
     * @return
     * @Description: 通过tenderId 删除
     * @author mazc
     */
    Integer deleteBidPrcieByTenderId(String tenderID);

    /**
     * @Description: 获得供应商报价的最大轮次集合
     * @author mazc
     * @param supplierList
     * @return
     */
//	Map<String,Integer> getSupplierMaxPriceRoundMap(String tenderId , List<Supplier> supplierList);

    /**
     * @param supplierList
     * @return
     * @Description: 获得供应商报价的最大轮次集合
     * @author mazc
     */
    Map<String, Integer> getSupplierMaxPriceRoundMap(String tenderId, String supplierId);

    /**
     * @param tenderId
     * @param round
     * @param supplierId
     * @return
     * @Description: 获得项目下指定轮次报价供应商报价完成情况
     * @author guoyr
     */
    Map<String, Boolean> getSupplierBidPriceRoundComplateStatus(@Param("tenderId") String tenderId, @Param("supplierId") String supplierId, @Param("round") int round);


    /**
     * @param tenderId
     * @param bidprcieId
     * @param supplierId
     * @return
     * @Description: 获得供应商的报价结果
     * @author mazc
     */
    List<BidPriceHisResult> getBidPriceHisResultList(String tenderId, String bidPriceId, String supplierId);


    /**
     * @param tenderId
     * @param bidPriceId
     * @param round
     * @return
     * @Description: 按轮次获得历史报价结果
     * @author mazc
     */
    List<BidPriceHisResult> getBidPriceHisResultListByRound(String tenderId, String bidPriceId, int round);

    /**
     * @param tenderId
     * @param supplierId
     * @param round
     * @return
     * @Description: 获得供应商的历史报价
     * @author guoyr
     */
    List<BidPriceHisResult> getSupplierBidPriceHisResultListByRound(String tenderId, String supplierId, int round);


    /**
     * @param tenderId
     * @param supplierId
     * @param bidPriceRound
     * @return
     * @Description: 通过TenderId、SupplierId、bidPriceRound 查询报价
     * @author mazc
     */
    BidPriceHisResult getBidPriceHisResultByTenderId(String tenderId, String supplierId, int bidPriceRound);


    /**
     * @param supplierId
     * @param bidPriceId
     * @param bidPriceRound
     * @return
     * @Description:
     * @author mazc
     */
    BidPriceHisResult getHisResultPriceIdAndSupplierIdAndPriceRound(String supplierId, String bidPriceId, int bidPriceRound);


    /**
     * @param supplierId
     * @param bidPriceRound
     * @return
     * @Description: 根据供应商id查询历史报价
     * @author mazc
     */
    List<BidPriceHisResult> getBidPriceHisResultBySupplierId(String supplierId, int bidPriceRound);

    /**
     * @param tenderId
     * @param bidPriceId
     * @return
     * @Description: 通过TenderId查询历史报价集合
     * @author mazc
     */
    List<BidPriceHisResult> getBidPriceHisResultByTenderIdList(String tenderId, String bidPriceId);


    /**
     * @param tenderId
     * @param supplierId
     * @param bidPriceId
     * @param bidPriceHisResult
     * @return
     * @Description: 保存历史报价
     * @author mazc
     */
    boolean saveSupplierHisBidPriceResulta(String tenderId, String supplierId, String bidPriceId, BidPriceHisResult bidPriceHisResult);


    boolean updateAssignProperty(BidPriceHisResult evaluationStep, String[] strs);


    List<BidPriceHisResult> getBidPriceHisResultByTenderId(String tenderId, int bidPriceRound);

    boolean saveSupplierReBidPriceHisResult(String tenderId, String supplierId, String roundId, List<BidPriceHisResult> bidPriceHisResultList);

    boolean saveSupplierReBidPriceHisResultAndBidPriceFile(String tenderId, String supplierId, String roundId, List<BidPriceHisResult> bidPriceHisResultList, String downUrl, String fileName);

    boolean saveUpateSupplierReBidPriceHisResult(String tenderId, String supplierId, String roundId, List<BidPriceHisResult> bidPriceHisResultList);

}



