package com.gx.obe.server.management.evaluation.service;

import com.baomidou.mybatisplus.extension.service.IService;

import java.math.BigDecimal;
import java.util.List;
import com.gx.obe.server.management.evaluation.entity.EvaluationFactorItem;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface EvaluationFactorItemService extends IService<EvaluationFactorItem> {
 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeEvaluationFactorItemList 
	 */
 	Integer updateByBatch (List<EvaluationFactorItem> ObeEvaluationFactorItemList);
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeEvaluationFactorItemList 
	 */
	Integer insertByBatch (List<EvaluationFactorItem> ObeEvaluationFactorItemList);
	
	
	/**
	 * @Description: 智能计算得分
	 * @author mazc
	 * @param supplierId
	 * @param factorCode
	 * @param tenderId
	 * @param highestScore
	 * @return 
	 */
	BigDecimal getAIScore(String supplierId, String factorCode, String tenderId, BigDecimal highestScore);
	
	
	
	List<EvaluationFactorItem> getItemByTenderIdAndSupplierIdAndfactorCode(String tenderId,String supplierId,String factorCode);
	
	
	 boolean deleteByTenderId(String tenderId);
}



