package com.gx.obe.server.management.evaluation.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.evaluation.entity.SupplierEvaluationFactor;

/**
 * @Description:
 * @author mazc
 */
public interface SupplierEvaluationFactorService extends IService<SupplierEvaluationFactor> {
    /**
     * @Description: 批量更新
     * @author mazc
     * @param ObeSupplierEvaluationFactorList
     */
    Integer updateByBatch(List<SupplierEvaluationFactor> ObeSupplierEvaluationFactorList);
    
    /**
     * @Description: 批量插入
     * @author mazc
     * @param ObeSupplierEvaluationFactorList
     */
    Integer insertByBatch(List<SupplierEvaluationFactor> ObeSupplierEvaluationFactorList);
    
    /**
     * @Description: 获得已评审的结果
     * @author mazc
     * @param factorCode
     * @param supplierId
     * @return
     */
    List<SupplierEvaluationFactor> getSupplierEvaluationFactorByFactorCodeAndSupplierId(String factorCode, String supplierId);
    
    /**
     * @Description: 保存或更新
     * @author mazc
     * @param supplierEvaluationFactorList
     * @return
     */
    int batchSaveOrUpdate(List<SupplierEvaluationFactor> supplierEvaluationFactorList, String[] attributes);
    
    /**
     * @Description: 按照id更新非空字段
     * @author mazc
     * @param supplierEvaluationFactor
     * @return
     */
    boolean updateEventById(SupplierEvaluationFactor supplierEvaluationFactor);
    
    /**
     * @Description: 通过tenderId 获取
     * @author mazc
     * @param tenderId
     * @return
     */
    List<SupplierEvaluationFactor> getEntityListByTenderId(String tenderId);
    
    /**
     * @Description: 按照tenderid删除
     * @author mazc
     * @param tenderId
     * @return
     */
    int deleteByTenderId(String tenderId);
    
    /**
     * @Description: 指定字段修改
     * @author chenxw
     * @param supplierEvaluationFactor
     * @param attributes
     * @return 
     */
    boolean updateAssignProperty(SupplierEvaluationFactor supplierEvaluationFactor, String[] attributes);
    
}
