package com.gx.obe.server.management.expert.entity;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
/** 
 * @Description: 评标步骤分配的专家
 * @author mazc 
 */

@TableName("obe_evaluation_step_expert")
public class EvaluationStepExpert extends Model<EvaluationStepExpert> {
    
	private static final long serialVersionUID=1L;

    /**
     * 评标步骤分配专家主键
     */
	@TableId("STEP_EXPERT_ID")
        private String id;
    /**
     * 评标步骤外键
     */
    @TableField("STEP_ID")
        private String stepId;
    /**
     * 项目外键
     */
    @TableField("TENDER_ID")
        private String tenderId;
    /**
     * 评审成员外键
     */
    @TableField("USER_ID")
        private String userId;

    /** 
     * @author chenxw
     * @param tenderId
     * @param stepId
     * @param userId 
     */
    public EvaluationStepExpert(String id, String tenderId, String stepId, String userId){
        this.id = id;
        this.tenderId = tenderId;
        this.stepId = stepId;
        this.userId = userId;
    }

    public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getStepId(){
        return stepId;
        }

        public void setStepId(String stepId) {
        this.stepId = stepId;
        }

    public String getTenderId(){
        return tenderId;
        }

        public void setTenderId(String tenderId) {
        this.tenderId = tenderId;
        }

    public String getUserId(){
        return userId;
        }

        public void setUserId(String userId) {
        this.userId = userId;
        }

    public static final String STEP_EXPERT_ID ="STEP_EXPERT_ID";

    public static final String STEP_ID ="STEP_ID";

    public static final String TENDER_ID ="TENDER_ID";

    public static final String USER_ID ="USER_ID";

@Override
protected Serializable pkVal(){
        return this.id;
    }

@Override
public String toString() {//stepExpertId
    return "EvaluationStepExpert{" +
            ", id=" + id +
            ", stepId=" + stepId +
            ", tenderId=" + tenderId +
            ", userId=" + userId +
    "}";
    }
    }
