package com.gx.obe.server.management.im.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.im.entity.MessageFile;
import com.gx.obe.server.management.im.service.MessageFileService;

import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@Api(tags = "")
@RestController
@AllArgsConstructor
@RequestMapping("/im/messageFile")
public class MessageFileController extends BaseController<MessageFileService,MessageFile>{
	@Autowired
	public MessageFileService messageFileServices;
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param MessageFileList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<MessageFile> MessageFileList) {
		return messageFileServices.insertByBatch(MessageFileList);
	}
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param MessageFileList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<MessageFile> MessageFileList) {
		return messageFileServices.updateByBatch(MessageFileList);
	}

	@GetMapping("/getLixianFileCount")
	public int getLixianFileCount(String fileName) {
		return messageFileServices.getLixianFileCount(fileName);
	}
	
	@PostMapping("/saveOrUpdate")
	public boolean saveOrUpdate(@RequestBody MessageFile messageFile) {
		return messageFileServices.saveUpdate(messageFile);
	}
	@GetMapping("/getMessageFileListByReadTyepAndReceiveId")
	public List<MessageFile> getMessageFileListByReadTyepAndReceiveId(String readType, String id) {
		return messageFileServices.getMessageFileListByReadTyepAndReceiveId(readType, id);
	}
}