package com.gx.obe.server.management.log.entity;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.util.Date;

import javax.validation.constraints.NotBlank;

import org.springframework.format.annotation.DateTimeFormat;

import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;


import com.baomidou.mybatisplus.annotation.TableName;

/** 
 * @Description: 
 * @author mazc 
 */
@TableName("obe_sys_log")
public class SysLog extends Model<SysLog> {

	private static final long serialVersionUID = 1L;

	/**
	 * 日志编号
	 */
	@TableId("LOG_ID")
	private Long id;
	/**
	 * 日志标题
	 */
	@NotBlank(message = "日志标题不能为空")
	@TableField("TITLE")
	private String title;
	/**
	 * 日志等级
	 */
	@NotBlank(message = "日志等级不能为空")
	@TableField("LEVEL")
	private Integer level;
	/**
	 * 操作者
	 */
	@TableField("CREATE_USER")
	private String createUser;
	/**
	 * 创建时间
	 */
	@TableField("CREATE_TIME")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createTime;
	/**
	 * 操作ip地址
	 */
	@TableField("REMOTE_ADDR")
	private String remoteAddr;
	/**
	 * 请求uri
	 */
	@TableField("REQUEST_URI")
	private String requestUri;
	/**
	 * 操作方式
	 */
	@TableField("METHOD")
	private String method;
	/**
	 * 提交数据
	 */
	@TableField("PARAMS")
	private String params;
	/**
	 * 执行时间
	 */
	@TableField("TIME")
	private Long time;
	/**
	 * 异常信息
	 */
	@TableField("EXCEPTION")
	private String exception;
	/**
	 * 返回结果
	 */
	@TableField("RETURN_VALUE")
	private String returnValue;
	

   
    public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getTitle(){
        return title;
	}

	public void setTitle(String title) {
        this.title = title;
	}

    public Integer getLevel(){
        return level;
	}

	public void setLevel(Integer level) {
        this.level = level;
	}

    public String getCreateUser(){
        return createUser;
	}

	public void setCreateUser(String createUser) {
        this.createUser = createUser;
	}

    public Date getCreateTime(){
        return createTime;
	}

	public void setCreateTime(Date date) {
        this.createTime = date;
	}

    public String getRemoteAddr(){
        return remoteAddr;
	}

	public void setRemoteAddr(String remoteAddr) {
        this.remoteAddr = remoteAddr;
	}

    public String getRequestUri(){
        return requestUri;
	}

	public void setRequestUri(String requestUri) {
        this.requestUri = requestUri;
	}

    public String getMethod(){
        return method;
	}

	public void setMethod(String method) {
        this.method = method;
	}

    public String getParams(){
        return params;
	}

	public void setParams(String params) {
        this.params = params;
	}

    public Long getTime(){
        return time;
	}

	public void setTime(Long time) {
        this.time = time;
	}

    public String getException(){
        return exception;
	}

	public void setException(String exception) {
        this.exception = exception;
	}

    public String getReturnValue(){
        return returnValue;
	}

	public void setReturnValue(String returnValue) {
        this.returnValue = returnValue;
	}


    public static final String LOG_ID ="LOG_ID";
	
    public static final String TITLE ="TITLE";
	
    public static final String LEVEL ="LEVEL";
	
    public static final String CREATE_USER ="CREATE_USER";
	
    public static final String CREATE_TIME ="CREATE_TIME";
	
    public static final String REMOTE_ADDR ="REMOTE_ADDR";
	
    public static final String REQUEST_URI ="REQUEST_URI";
	
    public static final String METHOD ="METHOD";
	
    public static final String PARAMS ="PARAMS";
	
    public static final String TIME ="TIME";
	
    public static final String EXCEPTION ="EXCEPTION";
	
    public static final String RETURN_VALUE ="RETURN_VALUE";
	
	@Override
	protected Serializable pkVal(){
        return this.id;
    }

	@Override
	public String toString() {
    return "SysLog{" +
		", id=" + id +
		", title=" + title +
		", level=" + level +
		", createUser=" + createUser +
		", createTime=" + createTime +
		", remoteAddr=" + remoteAddr +
		", requestUri=" + requestUri +
		", method=" + method +
		", params=" + params +
		", time=" + time +
		", exception=" + exception +
		", returnValue=" + returnValue +
	"}";
	}
}