package com.gx.obe.server.management.menu.service;

import com.baomidou.mybatisplus.extension.service.IService;
import java.util.List;

import com.gx.obe.server.management.menu.entity.AuthMenuEntity;
import com.gx.obe.server.management.menu.entity.AuthRoleMenu;
 
/** 
 * @Description: 
 * @author mazc 
 */
public interface AuthRoleMenuService extends IService<AuthRoleMenu> {
 	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param AuthRoleMenuList 
	 */
 	Integer updateByBatch (List<AuthRoleMenu> AuthRoleMenuList);
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param AuthRoleMenuList 
	 */
	Integer insertByBatch (List<AuthRoleMenu> AuthRoleMenuList);
	
	/**
	 * @Description: 获得角色的菜单
	 * @author mazc
	 * @param roleId
	 * @return 
	 */
	List<Object> getRoleResourceList(String roleId);
	
	
	/**
	 * @Description: 为角色分配菜单
	 * @author mazc
	 * @param authRoleId
	 * @param userId
	 * @param menuList
	 * @return 
	 */
	boolean assignRoleResource(String authRoleId,String userId, List<AuthMenuEntity> menuList);
}



