package com.gx.obe.server.management.other.controller;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gx.obe.server.common.base.BaseController;
import com.gx.obe.server.management.other.entity.InquireEnvelop;
import com.gx.obe.server.management.other.service.InquireEnvelopService;

import lombok.AllArgsConstructor;
/** 
 * @Description: 
 * @author mazc 
 */
@RestController
@AllArgsConstructor
@RequestMapping("/inquireEnvelop")
public class InquireEnvelopController extends BaseController<InquireEnvelopService,InquireEnvelop>{
	@Autowired
	public InquireEnvelopService inquireEnvelopServices;
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeInquireEnvelopList 
	 */
	@PostMapping("/insertByBatch")
	public int insertByBatch(@RequestBody List<InquireEnvelop> ObeInquireEnvelopList) {
		return inquireEnvelopServices.insertByBatch(ObeInquireEnvelopList);
	}
	
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeInquireEnvelopList 
	 */
	@PostMapping("/updateByBatch")
	public int updateByBatch(@RequestBody List<InquireEnvelop> ObeInquireEnvelopList) {
		return inquireEnvelopServices.updateByBatch(ObeInquireEnvelopList);
	}

	
	/**
	 * @Description: 获得询标函列表
	 * @author mazc
	 * @param tenderId
	 * @param userId
	 * @param supplierId
	 * @param stepId
	 * @return
	 */
	@GetMapping("/getInquireEnvelopList")
	public List<InquireEnvelop> getInquireEnvelopList(String tenderId, String userId, String supplierId, String stepId){
		return inquireEnvelopServices.getInquireEnvelopList(tenderId, userId, supplierId, stepId);
	}
	
	@PostMapping("/saveOrUpdate")
	public boolean saveOrUpdate(@RequestBody InquireEnvelop inquireEnvelop){ 
		return inquireEnvelopServices.saveOrUpdate(inquireEnvelop);
	}
	
	@PostMapping("/updateAssignProperty")
	public boolean updateAssignProperty(@RequestBody InquireEnvelop inquireEnvelop) {
		return inquireEnvelopServices.updateAssignProperty(inquireEnvelop);
	}
	
}