package com.gx.obe.server.management.price.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.price.entity.ReBidPriceRound;

/** 
 * @Description: 
 * @author wangxiang 
 */
@Mapper
public interface ReBidPriceRoundMapper extends BaseMapper<ReBidPriceRound> {

	/**
	 * @Description: 获得轮次名称
	 * @author wangxiang
	 * @param tenderId
	 * @param i
	 * @return 
	 */
	String getRoundName(@Param("tenderId")String tenderId, @Param("round")int round);

	/**
	 * @Description: 获得项目的最大伦次
	 * @author wangxiang
	 * @param tenderId
	 * @return 
	 */
	Integer getMaxRound(@Param("tenderId")String tenderId);

	Integer deleteByTenderId(@Param("tenderId")String tenderId);
	
	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param ObeBidpriceRound
	 * @param attributes
     */
    Integer updateAssignProperty(@Param("ObeBidpriceRound")ReBidPriceRound ObeBidpriceRound, @Param("attributes")String[] attributes);
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param ObeBidpriceRoundList
	 * @param attributes
     */
    Integer batchUpdateProperty(@Param("ObeBidpriceRoundList")List<ReBidPriceRound> ObeBidpriceRoundList, @Param("attributes")String[] attributes);
    
    Integer updateRoundStatus(@Param("roundId")String roundId, @Param("status")String status);
    
    ReBidPriceRound getMaxRoundInfo(@Param("tenderId")String tenderId);
	
}
