package com.gx.obe.server.management.price.service.impl;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.ArrayList;
import java.util.List;
import com.gx.obe.server.common.utils.IDUtils;
import com.gx.obe.server.common.utils.StringUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import java.util.List;
import com.gx.obe.server.management.price.entity.BidPriceRoundStatus;
import com.gx.obe.server.management.price.dao.ObeBidPriceRoundStatusMapper;
import com.gx.obe.server.management.price.service.ObeBidPriceRoundStatusService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/** 
 * @Description: 
 * @author mazc 
 */
@Service
@Transactional
public class ObeBidPriceRoundStatusServiceImpl extends ServiceImpl<ObeBidPriceRoundStatusMapper, BidPriceRoundStatus> implements ObeBidPriceRoundStatusService {

	@Autowired
	private ObeBidPriceRoundStatusMapper obeBidPriceRoundStatusMapper;
	
	/**
	 * @Description: 批量更新
	 * @author mazc
	 * @param ObeBidPriceRoundStatusList 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public Integer updateByBatch(List<BidPriceRoundStatus> ObeBidPriceRoundStatusList) {
		return obeBidPriceRoundStatusMapper.updateBatchList(ObeBidPriceRoundStatusList);
	}
	
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeBidPriceRoundStatusList 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public Integer insertByBatch(List<BidPriceRoundStatus> ObeBidPriceRoundStatusList) {
		return obeBidPriceRoundStatusMapper.insertByBatch(ObeBidPriceRoundStatusList);
	}
	
	/**
     * @Description: 指定字段修改
     * @author chenxw
     * @param BidPriceRoundStatus
	 * @param attributes
     */
	@Override
    public boolean updateAssignProperty(BidPriceRoundStatus BidPriceRoundStatus, String[] attributes) {
		return obeBidPriceRoundStatusMapper.updateAssignProperty(BidPriceRoundStatus, attributes) > 0;
	}
    
    /**
     * @Description: 批量指定字段修改
     * @author chenxw
     * @param ObeBidPriceRoundStatusList
	 * @param attributes
     */
	@Override
    public Integer batchUpdateProperty(List<BidPriceRoundStatus> ObeBidPriceRoundStatusList, String[] attributes) {
		return obeBidPriceRoundStatusMapper.batchUpdateProperty(ObeBidPriceRoundStatusList, attributes);
	}
	
	/** 
	 * @Description: 批量添加或跟新
	 * @author chenxw
	 * @param ObeBidPriceRoundStatusList
	 * @param attributes
	 * @return 
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
    public Integer batchSaveOrUpdate(List<BidPriceRoundStatus> ObeBidPriceRoundStatusList, String[] attributes) {
        List<BidPriceRoundStatus> insertObeBidPriceRoundStatusList = new ArrayList<>();
        List<BidPriceRoundStatus> updateObeBidPriceRoundStatusList = new ArrayList<>();
        for (BidPriceRoundStatus BidPriceRoundStatus : ObeBidPriceRoundStatusList) {
            if (StringUtils.isEmpty(BidPriceRoundStatus.getId())) {
                BidPriceRoundStatus.setId(IDUtils.getId());
                insertObeBidPriceRoundStatusList.add(BidPriceRoundStatus);
            } else {
                updateObeBidPriceRoundStatusList.add(BidPriceRoundStatus);
            }
        }
        int count = 0;
        if (insertObeBidPriceRoundStatusList.size() > 0) {
            count += obeBidPriceRoundStatusMapper.insertByBatch(insertObeBidPriceRoundStatusList);
        }
        if (updateObeBidPriceRoundStatusList.size() > 0) {
            count +=obeBidPriceRoundStatusMapper.batchUpdateProperty(updateObeBidPriceRoundStatusList, attributes);
        }
        return count;
    }

}
