package com.gx.obe.server.management.scancode.entity;

import java.io.Serializable;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonProperty;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/** 
 * @Description: 二维码详细信息
 * @author mazc 
 */
@Data
@AllArgsConstructor
@NoArgsConstructor 
public class QRCodeDetail implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7266407571206723165L;
	private String tid;
	@JsonProperty("QRcodeType")
	private String QRcodeType;
	private String signOriVal;
	private String requiredCACert;
	private String platformCode;
	private String hashCode;

	
	private String idCard;
	
	/**
	 * 需要签名的签章时生成批量文件的hash值列表
	 */
	private List<ScanCodeSign> hashCodeList;
	
	/**
	 * 签章图片的类型 00:个人签名
	 */
	private String sealImageType;
	
	
	
	/**
	 * 签章类型 01:个人
	 */
	private String sealBelong;
	
	private String personalTransactionCode;
}
