package com.gx.obe.server.management.software.service.impl;

import java.io.File;
import java.nio.file.Paths;
import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gx.obe.server.management.software.dao.ObeSoftwareMapper;
import com.gx.obe.server.management.software.entity.ObeSoftware;
import com.gx.obe.server.management.software.service.ObeSoftwareService;

/** 
 * @Description: 
 * @author mazc 
 */
@Service
@Transactional
public class ObeSoftwareServiceImpl extends ServiceImpl<ObeSoftwareMapper, ObeSoftware> implements ObeSoftwareService {

	@Autowired
	private ObeSoftwareMapper obeOtherSoftwareMapper;
	
	@Value("${upload.softwareFolder}")
	private String softwareFolder;
 
	
	/**
     * @Description: 指定字段修改
     * @author mazc
     * @param ObeSoftware
	 * @param attributes
     */
	@Override
   public boolean updateAssignProperty(ObeSoftware ObeSoftware, String[] attributes) {
		return obeOtherSoftwareMapper.updateAssignProperty(ObeSoftware, attributes) > 0;
	}
    
    /**
     * @Description: 批量指定字段修改
     * @author mazc
     * @param ObeSoftwareList
	 * @param attributes
     */
	@Override
   public Integer batchUpdateProperty(List<ObeSoftware> ObeSoftwareList, String[] attributes) {
		return obeOtherSoftwareMapper.batchUpdateProperty(ObeSoftwareList, attributes);
	}

	/** 
	 * @Description: 查询项软件项目列表分页查询
	 * @author mazc
	 * @param page
	 * @return 
	 */
	@Override
	public List<ObeSoftware> getSoftwareList(String status) {
		return obeOtherSoftwareMapper.getSoftwarePageList(status);
	}
	
	@Override
	public ObeSoftware getSoftwareByCode(String softwareCode) {
		QueryWrapper<ObeSoftware> queryWrapper = new QueryWrapper<>();
		queryWrapper.lambda().eq(ObeSoftware::getSoftwareCode, softwareCode);
		return obeOtherSoftwareMapper.selectOne(queryWrapper);
	}

	@Override
	public Boolean createSoftware(ObeSoftware obeOtherSoftware) {
		obeOtherSoftware.setCreateTime(new Date());
 		return obeOtherSoftwareMapper.insert(obeOtherSoftware) > 0;
	}

	@Override
	public Boolean deletSoftware(ObeSoftware otherSoftware) {
		File file = new File(Paths.get(softwareFolder + File.separator + otherSoftware.getSoftwareUrl()).toString());
		if (file.exists() && !file.delete()) {
			return false;
		}
		return obeOtherSoftwareMapper.deleteById(otherSoftware.getId()) > 0;
 	}
}
