package com.gx.obe.server.management.struct_new.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;

/**
 * @author mazc
 * @Description:
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("obe_finance")
public class ObeFinance extends Model<ObeFinance> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId("ID")
    private String id;
    /**
     * 项目ID
     */
    @TableField("TENDER_ID")
    private String tenderId;
    /**
     * 模型数据ID
     */
    @TableField("MODEL_DATA_ID")
    private String modelDataId;
    /**
     * 年度
     */
    @TableField("ANNUAL")
    private String annual;
    /**
     * 注册资本（万元）
     */
    @TableField("REGISTERED_CAPITAL")
    private BigDecimal registeredCapital;
    /**
     * 总资产（万元）
     */
    @TableField("TOTAL")
    private BigDecimal total;
    /**
     * 利润总额（万元）
     */
    @TableField("PROFIT_LOSS_PROFIT")
    private BigDecimal profitLossProfit;
    /**
     * 营业收入（万元）
     */
    @TableField("OPERATING_INCOME")
    private BigDecimal operatingIncome;
    /**
     * 资产负债率（%）
     */
    @TableField("LIABILITIES_RATE")
    private BigDecimal liabilitiesRate;
    /**
     * 流动资产（万元）
     */
    @TableField("CURRENT_ASSETS")
    private BigDecimal currentAssets;
    /**
     * 流动负债（万元）
     */
    @TableField("CURRENT_LIABILITIES")
    private BigDecimal currentLiabilities;
    /**
     * 流动比率（%）
     */
    @TableField("CURRENT_RATE")
    private BigDecimal currentRate;
    /**
     * 净利率（%）
     */
    @TableField("PROFIT_RATIO")
    private BigDecimal profitRatio;
    /**
     * 主营业务利润率（%）
     */
    @TableField("OPERATING_MARGIN")
    private BigDecimal operatingMargin;
    /**
     * 净利润（万元）
     */
    @TableField("RETAINED_PROFITS")
    private BigDecimal retainedProfits;
    /**
     * 企业名称
     */
    @TableField("COMPANY_NAME")
    private String companyName;
    /**
     * 净资产（万元）
     */
    @TableField("NET_WORTH")
    private BigDecimal netWorth;
    /**
     * 固定资产（万元）
     */
    @TableField("FIXED_ASSETS")
    private BigDecimal fixedAssets;
    /**
     * 现金流量净额（万元）
     */
    @TableField("NET_CASH_FLOW")
    private BigDecimal netCashFlow;
    /**
     * 净资产收益率（%）
     */
    @TableField("RETURN_ON_EQUITY")
    private BigDecimal returnOnEquity;
    /**
     * 总资产报酬率（%）
     */
    @TableField("RETURN_ON_TOTAL_ASSET")
    private BigDecimal returnOnTotalAsset;
    /**
     * 速动比率（%）
     */
    @TableField("QUICK_RATIO")
    private BigDecimal quickRatio;
    /**
     * 负债合计（万元）
     */
    @TableField("TOTALLIABILITIES")
    private BigDecimal totalliabilities;
    /**
     * 成本费用总额（万元）
     */
    @TableField("TOTALCOST")
    private BigDecimal totalcost;
    /**
     * 速动资产（万元）
     */
    @TableField("QUICKASSETS")
    private BigDecimal quickassets;
    /**
     * 主营业务利润（万元）
     */
    @TableField("MAIN_INCOME_PROFITS")
    private BigDecimal mainIncomeProfits;
    /**
     * 主营业务收入（万元）
     */
    @TableField("PRIME_OPERATING_REVENUE")
    private BigDecimal primeOperatingRevenue;

    /**
     * 资产负债表
     */
    @TableField(exist = false)
    private ObeBalanceSheet balanceSheet;
    /**
     * 损益表
     */
    @TableField(exist = false)
    private ObeProfitlossSheet profitlossSheet;
    /**
     * 现金流量表
     */
    @TableField(exist = false)
    private ObeCashSheet cashSheet;

}