package com.gx.obe.server.management.struct_new.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.struct_new.entity.ObeCertificate;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
public interface ObeCertificateService extends IService<ObeCertificate> {

    /**
     * @param ObeCertificateList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeCertificate> ObeCertificateList);

    /**
     * @param ObeCertificateList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeCertificate> ObeCertificateList);

    /**
     * @param ObeCertificate
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeCertificate ObeCertificate, String[] attributes);

    /**
     * @param ObeCertificateList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeCertificate> ObeCertificateList, String[] attributes);

    /**
     * @param ObeCertificateList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeCertificate> ObeCertificateList, String[] attributes);

    /**
     * @param projectLeaderId
     * @return
     * @Description: 获取证书列表
     * @author chenxw
     */
    List<ObeCertificate> getCertificateList(String projectLeaderId);
}



