package com.gx.obe.server.management.struct_new.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.gx.obe.server.management.struct_new.entity.ObeTemplateTable;

import java.util.List;

/**
 * @author mazc
 * @Description:
 */
public interface ObeTemplateTableService extends IService<ObeTemplateTable> {

    /**
     * @param ObeTemplateTableList
     * @Description: 批量更新
     * @author mazc
     */
    Integer updateByBatch(List<ObeTemplateTable> ObeTemplateTableList);

    /**
     * @param ObeTemplateTableList
     * @Description: 批量插入
     * @author mazc
     */
    Integer insertByBatch(List<ObeTemplateTable> ObeTemplateTableList);

    /**
     * @param ObeTemplateTable
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    boolean updateAssignProperty(ObeTemplateTable ObeTemplateTable, String[] attributes);

    /**
     * @param ObeTemplateTableList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    Integer batchUpdateProperty(List<ObeTemplateTable> ObeTemplateTableList, String[] attributes);

    /**
     * @param ObeTemplateTableList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    Integer batchSaveOrUpdate(List<ObeTemplateTable> ObeTemplateTableList, String[] attributes);

    /**
     * @param tenderId
     * @param supplierId
     * @param relChapterType
     * @param dataCode
     * @return
     * @Description: 获取小范本表格
     * @author chenxw
     */
    ObeTemplateTable getTemplateTable(String tenderId, String supplierId, String relChapterType, String dataCode);

    /**
     * @param tenderId
     * @param relChapterType
     * @param dataCode
     * @return
     * @Description: 获取小范本表格列表
     * @author chenxw
     */
    List<ObeTemplateTable> getTemplateTableList(String tenderId, String relChapterType, String dataCode);

}



