package com.gx.obe.server.management.struct_new.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gx.obe.server.common.utils.IDUtils;
import com.gx.obe.server.common.utils.StringUtils;
import com.gx.obe.server.management.struct_new.dao.ObeBalanceSheetMapper;
import com.gx.obe.server.management.struct_new.entity.ObeBalanceSheet;
import com.gx.obe.server.management.struct_new.service.ObeBalanceSheetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * @author mazc
 * @Description:
 */
@Service
@Transactional
public class ObeBalanceSheetServiceImpl extends ServiceImpl<ObeBalanceSheetMapper, ObeBalanceSheet> implements ObeBalanceSheetService {

    @Autowired
    private ObeBalanceSheetMapper obeBalanceSheetMapper;

    /**
     * @param ObeBalanceSheetList
     * @Description: 批量更新
     * @author mazc
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Integer updateByBatch(List<ObeBalanceSheet> ObeBalanceSheetList) {
        return obeBalanceSheetMapper.updateBatchList(ObeBalanceSheetList);
    }

    /**
     * @param ObeBalanceSheetList
     * @Description: 批量插入
     * @author mazc
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Integer insertByBatch(List<ObeBalanceSheet> ObeBalanceSheetList) {
        return obeBalanceSheetMapper.insertByBatch(ObeBalanceSheetList);
    }

    /**
     * @param ObeBalanceSheet
     * @param attributes
     * @Description: 指定字段修改
     * @author chenxw
     */
    @Override
    public boolean updateAssignProperty(ObeBalanceSheet ObeBalanceSheet, String[] attributes) {
        return obeBalanceSheetMapper.updateAssignProperty(ObeBalanceSheet, attributes) > 0;
    }

    /**
     * @param ObeBalanceSheetList
     * @param attributes
     * @Description: 批量指定字段修改
     * @author chenxw
     */
    @Override
    public Integer batchUpdateProperty(List<ObeBalanceSheet> ObeBalanceSheetList, String[] attributes) {
        return obeBalanceSheetMapper.batchUpdateProperty(ObeBalanceSheetList, attributes);
    }

    /**
     * @param ObeBalanceSheetList
     * @param attributes
     * @return
     * @Description: 批量添加或跟新
     * @author chenxw
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Integer batchSaveOrUpdate(List<ObeBalanceSheet> ObeBalanceSheetList, String[] attributes) {
        List<ObeBalanceSheet> insertObeBalanceSheetList = new ArrayList<>();
        List<ObeBalanceSheet> updateObeBalanceSheetList = new ArrayList<>();
        for (ObeBalanceSheet ObeBalanceSheet : ObeBalanceSheetList) {
            if (StringUtils.isEmpty(ObeBalanceSheet.getId())) {
                ObeBalanceSheet.setId(IDUtils.getId());
                insertObeBalanceSheetList.add(ObeBalanceSheet);
            } else {
                updateObeBalanceSheetList.add(ObeBalanceSheet);
            }
        }
        int count = 0;
        if (insertObeBalanceSheetList.size() > 0) {
            count += obeBalanceSheetMapper.insertByBatch(insertObeBalanceSheetList);
        }
        if (updateObeBalanceSheetList.size() > 0) {
            count += obeBalanceSheetMapper.batchUpdateProperty(updateObeBalanceSheetList, attributes);
        }
        return count;
    }

}
