package com.gx.obe.server.management.supplier.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.supplier.entity.SupplierEvaluationResult;

import java.util.List;
/** 
 * @Description: 
 * @author mazc 
 */
 @Mapper
public interface SupplierEvaluationResultMapper extends BaseMapper<SupplierEvaluationResult> {
	 
	/**
	 * @Description: 批量插入
	 * @author mazc
	 * @param ObeSupplierEvaluationResultList 
	 */
	Integer insertByBatch (@Param("ObeSupplierEvaluationResultList")List<SupplierEvaluationResult> ObeSupplierEvaluationResultList);


	Integer updateObeSupplierEvaluationResultBatchList (@Param("ObeSupplierEvaluationResultList")List<SupplierEvaluationResult> ObeSupplierEvaluationResultList);
	
	Integer updateUnqObeSupplierEvaluationResultBatchList(@Param("ObeSupplierEvaluationResultList")List<SupplierEvaluationResult> ObeSupplierEvaluationResultList);

	String getCreateSupplierEvaluationResultId(@Param("tenderId")String tenderId,@Param("supplierId") String supplierId);
	
	
	Integer createSupplierEvaluationResultId(@Param("resultId")String resultId,@Param("tenderId")String tenderId,@Param("supplierId") String supplierId);
	
	/**
	 * @Description: 删除投标人的评标结果\重新开始评审
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	Integer deleteRestartEvaluation(@Param("tenderId") String tenderId);
	
	/**
	 * @Description: 释放申请填写供应商评废标意见的独占资源
	 * @author mazc
	 * @param applyUserId
	 * @return 
	 */
	Integer updateApplyUserIdByUserId(@Param("applyUserId") String applyUserId);


	/**
	 * @Description: 申请意见
	 * @author wangxiang
	 * @param tenderId
	 * @param supplierId
	 * @param applyUserId
	 * @param opinionEditor
	 * @return 
	 */
	Integer getApply(@Param("tenderId")String tenderId, @Param("supplierId")String supplierId, @Param("applyUserId")String applyUserId, @Param("opinionEditor")String opinionEditor);

	/**
	 * @Description: 查询供应商评审意见记录
	 * @author wangxiang
	 * @param tenderId
	 * @param supplierId
	 * @return 
	 */
	Integer getOpinionCount(@Param("tenderId")String tenderId, @Param("supplierId")String supplierId);


	/**
	 * @Description: 插入供应商评审意见
	 * @author wangxiang
	 * @param id
	 * @param tenderId
	 * @param supplierId
	 * @param applyUserId
	 * @param opinionEditor
	 * @return 
	 */
	Integer insertSupplierOpinion(@Param("id")String id, @Param("tenderId")String tenderId, @Param("supplierId")String supplierId, @Param("applyUserId")String applyUserId, @Param("opinionEditor")String opinionEditor);

	/**
	 * @Description: 统计初审通过（不通过）的供应商数量
	 * @author wangxaing
	 * @param tenderId
	 * @param type
	 * @return
	 */
	Integer getSupplierQualifiedCount(@Param("tenderId")String tenderId, @Param("accessment")String accessment);

	/**
	 * @Description: 释放编辑供应商评审意见权限
	 * @author wangxiang
	 * @param tenderId
	 * @param supplierId
	 * @param applyUserId
	 * @return 
	 */
	Integer releaseEditSupplierEvaluationResult(@Param("tenderId")String tenderId, @Param("supplierId")String supplierId, @Param("applyUserId")String applyUserId);

	/**
	 * @Description: 修改供应商的废标状态
	 * @author wangxiang
	 * @param tenderId
	 * @param stepIndex 
	 * @param complete 
	 * @param unqualified 
	 */
	Integer updateSupplierEvaluationAccessmentStatus(@Param("tenderId")String tenderId, @Param("sortNo")int sortNo, @Param("accessment")String accessment, @Param("stepStatus")String stepStatus);

	/**
	 * @Description: 指定字段修改
	 * @author chenxw
	 * @param ObeSupplierEvaluationResult
	 * @param attributes
	 */
	Integer updateAssignProperty(@Param("ObeSupplierEvaluationResult")SupplierEvaluationResult ObeSupplierEvaluationResult, @Param("attributes")String[] attributes);

	/**
	 * @Description: 批量指定字段修改
	 * @author chenxw
	 * @param ObeSupplierEvaluationResultList
	 * @param attributes
	 */
	Integer batchUpdateProperty(@Param("ObeSupplierEvaluationResultList")List<SupplierEvaluationResult> ObeSupplierEvaluationResultList, @Param("attributes")String[] attributes);

}