package com.gx.obe.server.management.user.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gx.obe.server.management.user.entity.AuthRoleEntity;

 /**  
 * 
 * @author 
 * @Title: AuthRoleEntity
 * @Package com.gx.obe.server.management.user.entity  
 * @Description:   AuthRoleMapper 接口
 * @author: XiaoMa Pro - myzhichao@163.com
 * @date:   2019-04-29   
 * @version V1.0 
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved. 
 *  
 */
@Mapper
public interface AuthRoleMapper extends BaseMapper<AuthRoleEntity> {
	
	/**
	 * @Description: 根据角色类型获取角色列表
	 * @author mazc
	 * @param roleType
	 * @return 
	 */
	List<AuthRoleEntity> getRoleListByRoleType(@Param("roleType")String roleType);
	
	/**   
	 * @Title: getUserRoleList   
	 * @Description: 获得用户在指定终端的角色列表
	 * @param: @param TERMINAL_TYPE
	 * @param: @param USER_ID
	 * @param: @param ROLE_TYPE
	 * @param: @return      
	 * @return: List<Object>      
	 * @throws   
	 */  
	List<AuthRoleEntity> getUserRoleList(@Param("terminalType")String terminalType,@Param("userId") String userId ,@Param("ignoreRoleType")String ignoreRoleType);
	/**
	 * @Description:  根据加色名字查找角色列表
	 * @author mazc
	 * @param roleName
	 * @return 
	 */
	List<AuthRoleEntity> getQueryRoleListByRoleName(@Param("roleName")String roleName); 
}