package com.gx.obe.server.management.user.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gx.obe.server.management.evaluation.entity.EvaluationStep;
import com.gx.obe.server.management.user.entity.AuthUserEntity;


 /**  
 * 
 * @author 
 * @Title: AuthUserEntity
 * @Package com.gx.obe.server.management.user.entity  
 * @Description:   AuthUserMapper 接口
 * @author: XiaoMa Pro
 * @date:   2019-04-25   
 * @version V1.0 
 * @Copyright: 2019 www.msypro.com Inc. All rights reserved. 
 *  
 */
@Mapper
public interface AuthUserMapper extends BaseMapper<AuthUserEntity> {
	
    /**
     * @Description: 指定字段修改
     * @author chenxw
     * @param AuthUser
     */
    Integer updateAssignProperty (@Param("AuthUser")AuthUserEntity AuthUser, @Param("attributes")String[] attributes);
    
	
	Integer valLoginAuthority(@Param("userId")String userId, @Param("terminal")String terminal);
	
	/**
	 * @Description: 通过证书
	 * @author mazc
	 * @param certId
	 * @return 
	 */
	AuthUserEntity findCertId(@Param("certId")String certId);
	
	/**
	 * @Description: 
	 * @author mazc
	 * @param tenderId
	 * @param evaluationStep
	 * @return 
	 */
	List<AuthUserEntity>findEvaluationStepUserList(@Param("tenderId")String tenderId,@Param("evaluationStep") EvaluationStep evaluationStep);
	
	/**
	 * @Description: 查询项目所对用的用户信息  
	 * @author mazc
	 * @param tenderId
	 * @return 
	 */
	AuthUserEntity findUserInfoByTenderId(@Param("tenderId")String tenderId);
	
	/**
	 * @Description: 通过项目ID，查询当前项目下所有专家的用户信息
	 * @author mazc
	 * @param projectId
	 * @return 
	 */
	List<AuthUserEntity> getExpertByProjectId(@Param("projectId")String projectId);
	
	/**
	 * @Description: 获取当前系统临时用户数量
	 * @author mazc
	 * @return 
	 */
	Integer getTempUserNum();
	
	
	/**
	 * @Description: 根据用户名和用户类型，获得用户列表。
	 * @author mazc
	 * @param userType
	 * @param userName
	 * @return 
	 */
	List<AuthUserEntity> getUserListByUserName(@Param("userType")String userType, @Param("userName")String userName);
	
	/**
	 * @Description: 更新用户状态
	 * @author mazc
	 * @param id
	 * @param useStatus
	 * @return 
	 */
	Integer updateUsestatus(@Param("id")String id, @Param("useStatus")String useStatus); 
		
	 IPage<AuthUserEntity> getUserPageList(Page<AuthUserEntity> page, @Param("account")String account, @Param("userName")String userName,
			 @Param("roleType")String roleType) ;
		/**
		 * @Description:  获得评标步骤的评标专家信息（项目经理）
		 * @author mazc
		 * @param tenderId
		 * @param evaluationStep
		 * @return 
		 */
		List<AuthUserEntity> getEvaluationStepUserByManagerList(@Param("tenderId")String tenderId);
		
		
		
		List<AuthUserEntity> getGroupItemUserList(@Param("id")String id);
}